########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################


if {![info exists egglib(ver)]} {
	putlog "************************************************"
	putlog "             egglib_pub NOT FOUND !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "************************************************"	
	return
}

if {[expr {$egglib(ver) < 1.4}]} {
	putlog "************************************************"
	putlog "    YOUR VERSION OF egglib_pub IS TOO OLD !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "************************************************"
	putlog " version installed: $egglib(ver)"
	putlog " version required: 1.4"
	return
}

# o


#############################
#############################
####          ####
#############################
#############################

#    
proc ::ymhuk::pub.msg {text} {
	variable conf
	putserv "privmsg $conf(chan) :$text"
}

#  
proc ::ymhuk::notice {nick text} {
	variable conf
	putserv "notice $nick :$text"
}

# 
proc ::ymhuk::priv.msg {nick text} {
	putserv "privmsg $nick :$text"
}

# 
proc ::ymhuk::action {text} {
	variable conf
	putserv "privmsg $conf(chan) :\001action $text\001"
}


proc ::ymhuk::main {nick uhost handle chan text} {
	variable conf; variable ymhuk
	
	set list [list $conf(ver.viktorina) $conf(ver.anagramm) $conf(ver.sharads) $conf(ver.cat) $conf(ver.blitz)]
	set r [expr {rand()}]
	set temp 0
	for {set i 0} {$i < [llength $list]} {incr i} {
		incr temp [lindex $list $i]
		if {$r <= [expr {double($temp)/100}]} {
			set ymhuk(game.type) [expr {$i + 1}]
			break
		}
	}
	#set ymhuk(game.type) [expr int(rand() * $conf(rand))]
	switch "$ymhuk(game.type)" {
		1 {
			if {!$conf(viktorina)} {
				::ymhuk::main $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::plain.out.questions $nick $uhost $handle $chan $text
		}
		2 {
			if {!$conf(anagramm)} {
				::ymhuk::main $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::anagramm.out $nick $uhost $handle $chan $text
		}
		3 {
			if {!$conf(sharads)} {
				::ymhuk::main $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::sharads.out $nick $uhost $handle $chan $text
		}
		4 {
			if {!$conf(cat)} {
				::ymhuk::main $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::cat.out.questions $nick $uhost $handle $chan $text		
		}
		5 {
			if {!$conf(blitz)} {
				::ymhuk::main $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::blitz.out.questions $nick $uhost $handle $chan $text		
		}
	}
	return
}

proc ::ymhuk::main.hint1 {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$ymhuk(game.type)" {
		1 {
			::ymhuk::plain.hint1 $nick $uhost $handle $chan $text
		}
		2 {
			::ymhuk::anagramm.hint1 $nick $uhost $handle $chan $text
		}
		3 {
			::ymhuk::sharads.hint1 $nick $uhost $handle $chan $text
		}
		4 { return }
		5 { return }
	}
	return
}

proc ::ymhuk::main.hint2 {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$ymhuk(game.type)" {
		1 {
			::ymhuk::plain.hint2.allow $nick $uhost $handle $chan $text
		}
		2 {
			::ymhuk::anagramm.hint2.allow $nick $uhost $handle $chan $text
		}
		3 {
			::ymhuk::sharads.hint2.allow $nick $uhost $handle $chan $text
		}
		4 { return }
		5 { return }
	}
	return
}


#####################################
#####################################
####          ####
#####################################
#####################################

proc ::ymhuk::get.questions {} {
	variable conf; variable ymhuk
	#  
	switch "$conf(sql.enable)" {
	0 {
		if {$conf(viktorina)} {
			::ymhuk::plain.initialization
			if {![info exists ymhuk(q.positions)] || ![info exists ymhuk(baselength)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(viktorina) 0
			}
		}
		if {$conf(anagramm)} {
			::ymhuk::anagramm.init
			if {![info exists ymhuk(a.positions)] || ![info exists ymhuk(anagramm.base.length)] || ![llength $ymhuk(a.positions)]} {
				::ymhuk::anagramm.load.base
			}
			if {!$ymhuk(anagramm.base.length)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(anagramm) 0
			}
		}
		if {$conf(sharads)} {
			::ymhuk::sharads.init
			if {![info exists ymhuk(s.positions)] || ![info exists ymhuk(sharads.base.length)] || ![llength $ymhuk(s.positions)]} {
				::ymhuk::sharads.load.base
			}
			if {!$ymhuk(sharads.base.length)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(sharads) 0
			}
		}
		if {$conf(cat)} {
			::ymhuk::plain.initialization
			if {![info exists ymhuk(q.positions)] || ![info exists ymhuk(baselength)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034    !"
				set conf(cat) 0
			}
		}
		if {$conf(blitz)} {
			::ymhuk::plain.initialization
			if {![info exists ymhuk(q.positions)] || ![info exists ymhuk(baselength)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034 - !"
				set conf(blitz) 0
			}
		}
	}
	1 {
		if {![::ymhuk::sql.ping]} {
			::ymhuk::pub.msg "\0034      !   ."
			return
		}
		if {$conf(viktorina)} {
			::ymhuk::plain.sql.load.base
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(viktorina) 0
			}
		}
		if {$conf(anagramm)} {
			::ymhuk::anagramm.sql.load.base			
			if {!$ymhuk(anagramm.base.length)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(anagramm) 0
			}
		}
		if {$conf(sharads)} {
			::ymhuk::sharads.sql.load.base			
			if {!$ymhuk(sharads.base.length)} {
				::ymhuk::pub.msg "\0034  !"
				set conf(sharads) 0
			}
		}
		if {$conf(cat)} {
			set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions"]
			set ymhuk(baselength) [::mysql::fetch $q]
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034    !"
				set conf(cat) 0
			}
			::mysql::endquery $q
		}
		if {$conf(blitz)} {
			set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions"]
			set ymhuk(baselength) [::mysql::fetch $q]
			if {!$ymhuk(baselength)} {
				::ymhuk::pub.msg "\0034 - !"
				set conf(blitz) 0
			}
			::mysql::endquery $q
		}
	}
	}
	return
}

#  
proc ::ymhuk::start {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {$chan != $conf(chan)} {
		return
	}
	#    
	if {[info exists ymhuk(game)]} {
		#    
		::ymhuk::notice $nick "  !"
		return
	}
	::ymhuk::get.questions
	if {!$conf(viktorina) && !$conf(anagramm) && !$conf(sharads) && !$conf(cat) && !$conf(blitz)} {
		::ymhuk::pub.msg "\0034   ,       ! !"
		return
	}
	#  ,   
	::ymhuk::pub.msg "\00312 !"
	#   
	set lst ""
	if {$conf(viktorina) || $conf(cat) || $conf(blitz)} {
		set vikt_q "\00313 $ymhuk(baselength)\00312 [lindex {0   } [::ymhuk::check.number $ymhuk(baselength)]]"
		append lst "$vikt_q"
	}
	if {$conf(anagramm)} {
		set an_q "\00313 $ymhuk(anagramm.base.length)\00312 [lindex {0   } [::ymhuk::check.number $ymhuk(anagramm.base.length)]]"
		if {$lst != ""} {
			append lst ","
		}
		append lst "$an_q"
	}
	if {$conf(sharads)} {
		set sh_q "\00313 $ymhuk(sharads.base.length)\00312 [lindex {0   } [::ymhuk::check.number $ymhuk(sharads.base.length)]]"
		if {$lst != ""} {
			append lst ","
		}
		append lst "$sh_q"
	}
	::ymhuk::pub.msg "\00312,\00310 $nick\00312,   .  $lst."
	#    
	#  
	set ymhuk(game) 			1
	#  
	set ymhuk(start.nick) 		$nick
	#   
	set ymhuk(no.answer) 		0
	# 
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	#     
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
	return
}

#  
proc ::ymhuk::stop {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  
	if {$chan != $conf(chan)} {
		return
	}
	if {[info exists ymhuk(game)]} {
		set let [::ymhuk::command.let $nick]
		#          ! (,     )
		if {([::ymhuk::user.place $nick] <= $conf(command.places)) || ($nick == $ymhuk(start.nick)) || $let} {
			#  ( ,    )
			::ymhuk::pub.msg "\00312 !"
			::ymhuk::kill.timers
			unset ymhuk(game)
			# ,   
			set ymhuk(round) 0
		} else {
			# ,   
			::ymhuk::notice $nick "  !"
			return
		}
		return
	}
	return
}

proc ::ymhuk::command.let {nick} {
	variable conf
	set let 0
	if {$conf(let.op.command) && [isop $nick $conf(chan)]} {
		set let 1
	}
	foreach user [split $conf(command.nick) ","] {
		if {$nick == $user} {
			set let 1
			break
		}
	}
	if {[::ymhuk::get.remort $nick] >= $conf(r.commands)} {
		set let 1
	}
	return $let
} 


proc ::ymhuk::self.stop {} {
	variable ymhuk; variable conf
	if {$ymhuk(no.answer) == $conf(max.no.answer)} {
		::ymhuk::kill.timers
		unset ymhuk(game)
		set ymhuk(round) 0
		::ymhuk::pub.msg "\00312\00313 $conf(max.no.answer)\00312     .    ."
		return 1
	} else {
		return 0
	}
	return
}

#    
proc ::ymhuk::main.correct.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {(![info exists ymhuk(game)]) || (![info exists ymhuk(round)]) || ($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	}
	#      ,   
	if {([string equal -nocase [::ymhuk::filter $ymhuk(answer)] [::ymhuk::filter $text]])} {
		#    ,        
		if {$nick == $ymhuk(answered.nick)} {
			putlog "      :"
			putlog "  : $ymhuk(answered.nick)"
			putlog ": $nick"
			incr ymhuk(answer.chain)
			putlog ": $ymhuk(answer.chain)"
		#  ,   
		} else {
			putlog "      :"
			putlog "  : $ymhuk(answered.nick)"
			putlog ": $nick"
			putlog " : $ymhuk(answer.chain)"
			set ymhuk(answer.chain) 1
			#     
			set ymhuk(answered.nick) $nick
			putlog " : $ymhuk(answer.chain)"
		}
		#  
		set ymhuk(finish.sec)	[clock seconds]
		set ymhuk(finish.ms) 	[clock click -milliseconds]
		set sec 				[expr $ymhuk(finish.sec) - $ymhuk(start.sec)]
		set ms					[expr [string range [expr $ymhuk(finish.ms) - $ymhuk(start.ms)] 0 0] / 10.0]
		set ymhuk(answer.time) "[expr $sec + $ms]"
		#    
		switch "$ymhuk(game.type)" {
			1 {
				::ymhuk::plain.output $nick
			}
			2 {
				::ymhuk::anagramm.output $nick
			}
			3 {
				::ymhuk::sharads.output $nick
			}
			4 {
				::ymhuk::cat.output $nick
			}
			5 {
				::ymhuk::blitz.output $nick
			}
		}
		# 
		set ymhuk(round) 		0
		set ymhuk(no.answer)	0
		#       
		::ymhuk::kill.timers
		utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
	}
	return
}

#        
proc ::ymhuk::place.change {nick} {
	variable ymhuk; variable conf
	switch "$ymhuk(game.type)" {
		1 {
			::ymhuk::plain.out.change.place $nick
		}
		2 {
			::ymhuk::anagramm.out.change.place $nick
		}
		3 {
			::ymhuk::sharads.out.change.place $nick
		}
		4 {
			::ymhuk::cat.out.change.place $nick
		}
		5 {
			::ymhuk::blitz.out.change.place $nick
		}
	}
	#   , 
	if {$conf(liders) == 0} {
		return
	}
	#   ,      ,  
	foreach user [chanlist $conf(chan)] {
		if {[isbotnick $user]} {continue}
		set no_status 0
		foreach item [split $conf(no.change) ","] {
			if {$user == $item} {
				set no_status 1
				break
			} 
		}
		set place [::ymhuk::user.place $user]
		if {!$no_status} {
			if {($place > [expr $conf(places1) + $conf(places2) + $conf(places3)]) || ($place <= [expr $conf(places1) + $conf(places2)])} {
				pushmode $conf(chan) -$conf(flag3) $user
			}
			if {($place > [expr $conf(places2) + $conf(places1)]) || ($place <= $conf(places1))} {
				pushmode $conf(chan) -$conf(flag2) $user
			}
			if {($place > $conf(places1))} {
				pushmode $conf(chan) -$conf(flag1) $user
			}
		}
		if {$conf(places3) > 0} {
			for {set i [expr $conf(places2) + $conf(places1) + 1]} {$i <= [expr $conf(places3) + $conf(places2) + $conf(places1)]} {incr i} {
				if {$user == [::ymhuk::user.on.place $i]} {
					pushmode $conf(chan) +$conf(flag3) $user
				} 
			}
		}
		if {$conf(places2) > 0} {
			for {set i [expr $conf(places1) + 1]} {$i <= [expr $conf(places2) + $conf(places1)]} {incr i} {
				if {$user == [::ymhuk::user.on.place $i]} {
					pushmode $conf(chan) +$conf(flag2) $user
				} 
			}
		}
		if {$conf(places1) > 0} {
			for {set i 1} {$i <= $conf(places1)} {incr i} {
				if {$user == [::ymhuk::user.on.place $i]} {
					pushmode $conf(chan) +$conf(flag1) $user
				} 
			}
		}
	}
	return
}

####################################
####################################
####################################
####          ####
####################################
####################################
####################################

################################################################
####      ,   .    ####
################################################################

#  
proc ::ymhuk::check.user {nick} {
	#   
	if {([validuser $nick]) && ([getuser $nick xtra ymhuk] != "")} { return 1 } else { return 0	}
}

#  
proc ::ymhuk::set.user {nick} {
	if {![validuser $nick]} {
		#  ,   
		adduser $nick *!*@*
	}
	#     
	setuser $nick xtra ymhuk "0 0 0 9999"
	return
}

#     
proc ::ymhuk::increase.on.answer {nick} {
	variable ymhuk
	# 
	if {![::ymhuk::check.user $nick]} {
		::ymhuk::set.user $nick
	}
	#    
	set ymhuk(place.before) [::ymhuk::user.place $nick]
	#     
	set points_list [getuser $nick xtra ymhuk]
	set score [lindex [split $points_list " "] 0]
	set answers [lindex [split $points_list] 1]
	set answer_chain [lindex [split $points_list " "] 2]
	set seconds [lindex [split $points_list " "] 3]
	#   
	set score [expr $score + $ymhuk(bonus)]
	set answers [expr $answers + 1]
	#        
	if {($ymhuk(answer.chain) > $answer_chain) || ($answer_chain == "")} {
		# 
		set answer_chain $ymhuk(answer.chain)
	}
	#        
	if {($ymhuk(answer.time) < $seconds) || ($seconds == "")} {
		# 
		set seconds $ymhuk(answer.time)
	}
	#   
	set points_list "$score $answers $answer_chain $seconds"
	setuser $nick xtra ymhuk $points_list
	setuser $nick xtra idle "[clock seconds]"
	#       
	set ymhuk(place.after) [::ymhuk::user.place $nick]
	#       
	::ymhuk::place.change $nick
	return
}

#  
proc ::ymhuk::decrease {nick points} {
	variable ymhuk
	# 
	if {![::ymhuk::check.user $nick]} {
		return
	}
	#    
	set ymhuk(place.before) [::ymhuk::user.place $nick]
	#  ()
	set points_list [getuser $nick xtra ymhuk]
	#
	set score [expr [lindex [split $points_list " "] 0] - $points]
	#   
	if {$score < 0} {
		set score 0
	}
	#  
	set points_list [lreplace [split $points_list " "] 0 0 $score]
	setuser $nick xtra ymhuk $points_list
	setuser $nick xtra idle "[clock seconds]"
	#       
	set ymhuk(place.after) [::ymhuk::user.place $nick]
	#    
	::ymhuk::place.change $nick
	return
}

########################################################
####             ####
########################################################

# 
proc ::ymhuk::get.score {nick} {
	set points_list [getuser $nick xtra ymhuk]
	set score [lindex [split $points_list " "] 0]
	return $score
}

#- 
proc ::ymhuk::get.answers {nick} {
	set points_list [getuser $nick xtra ymhuk]
	set answers [lindex [split $points_list " "] 1]
	return $answers
}

#  
proc ::ymhuk::get.answer.chain {nick} {
	set points_list [getuser $nick xtra ymhuk]
	set answer_chain [lindex [split $points_list " "] 2]
	return $answer_chain
}

#  
proc ::ymhuk::get.seconds {nick} {
	set points_list [getuser $nick xtra ymhuk]
	set seconds [lindex [split $points_list " "] 3]
	return $seconds
}

#   
proc ::ymhuk::user.on.place {place} {
	set sorted [::ymhuk::sort.users 1]
	set user [lindex [split [lindex $sorted [expr $place - 1]] " "] 0]
	return $user
}

#   
proc ::ymhuk::get.news {nick} {
	if {[getuser $nick xtra ymhuk] == ""} {
		return no
	}
	if {[getuser $nick xtra ymhuk] != ""} {
		if {[getuser $nick xtra news] == ""} {
			return no
		} else {
			return [getuser $nick xtra news]
		}
	}
}

#     
proc ::ymhuk::get.idle {nick} {
	if {[getuser $nick xtra ymhuk] == ""} {
		return no
	}
	if {[getuser $nick xtra ymhuk] != ""} {
		if {[getuser $nick xtra idle] == ""} {
			return no
		} else {
			return [getuser $nick xtra idle]
		}
	}
}

# 
proc ::ymhuk::set.sex {nick uhost handle text} {
	if {![::ymhuk::check.user $nick]} {
		::ymhuk::priv.msg "\00312         ."
		return
	}
	switch "$text" {
		m {
			setuser $nick xtra sex $text
			::ymhuk::priv.msg $nick "\00312   ."
		}
		w {
			setuser $nick xtra sex $text
			::ymhuk::priv.msg $nick "\00312   ."
		}
		default {
			::ymhuk::priv.msg $nick "\00312 \00310 !sex m\00312     \00310 !sex w\00312   ."
		}
	}
	return
}

# 
proc ::ymhuk::sex.check {nick} {
	if {[getuser $nick xtra ymhuk] == ""} {
		return 0
	}
	if {[getuser $nick xtra ymhuk] != ""} {
		if {[getuser $nick xtra sex] == ""} {
			return no
		} else {
			return [getuser $nick xtra sex]
		}
	}
} 

#   
proc ::ymhuk::get.title.nick {nick} {
variable conf
	set title ""
	if {[::ymhuk::check.user $nick] == 0} {
		set title $conf(no.title)
		return $title
	}
	if {[getuser $nick xtra title] != ""} {
		return [getuser $nick xtra title]
	}
	set sex 	[::ymhuk::sex.check $nick]
	set score 	[::ymhuk::get.score $nick]
	set i 0
	foreach item $conf(title.score) {
		if {$score < $item} {
			switch "$sex" {
				m {	set title [lindex $conf(man.titles) $i]		}
				w {	set title [lindex $conf(woman.titles) $i] 	}
				0 {	set title $conf(no.title)					}
				default { set title $conf(no.sex)				}
			}
			break
		}
		incr i
	}
	if {$title == ""} {
		switch "$sex" {
			m {	set title $conf(man.max.title) $i]		}
			w {	set title $conf(woman.max.title) $i] 	}
			0 {	set title $conf(no.title)				}
			default { set title $conf(no.sex)			}
		}
		return $title
	}
	return $title
}

#   
proc ::ymhuk::get.title.place {place} {
	set user [::ymhuk::user.on.place $place]
	set title [::ymhuk::get.title.nick $user]
	return $title
}


#    
proc ::ymhuk::user.place {nick} {
	set sorted [::ymhuk::sort.users 1]
	set i 1
	#     
	foreach user $sorted {
		if {[lindex [split $user " "] 0] == $nick} {break}
		incr i
	}
	set user_place $i
	return $user_place
}

#      
proc ::ymhuk::diference {nick} {
	set sorted [::ymhuk::sort.users 1]
	#        
	foreach user $sorted {
		if {[lindex [split $user " "] 0] == $nick} {break}
		set before [lindex [split $user " "] 0]
	}
	#  
	set diference ""
	#    ,   
	if {[::ymhuk::user.place $nick] > 1} {
		set diference [expr [::ymhuk::get.score $before] - [::ymhuk::get.score $nick] + 1]
	}
	return $diference
}

###############################################
####            ####
###############################################

# 
#$text -      (1 - , 2 -  , 3 - -  , 4 -   )
proc ::ymhuk::sort.users {text} {
	set users ""
	#  ,  
	foreach user [userlist] {
		#putlog "$user"
		if {[getuser $user xtra ymhuk] == ""} {continue}
		lappend users "$user [getuser $user xtra ymhuk] "
	}
	set sorted ""
	#     
	foreach item [lsort -real -decreasing -index $text $users] {
		lappend sorted "$item"
		#putlog "$item"
	}
	return $sorted
}

#  
proc ::ymhuk::top.users {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {$chan != $conf(chan)} {
		return
	}
	#     
	set sorted [::ymhuk::sort.users 1]
	switch [catch {expr $text}] {
		0 { if {(0 < $text) && ($text < 11)} {set last $text} else {set last 5} }
		1 {	set last 5 }
	}
	set i 0
	#    
	set sorted_color "\00312  :\0033 "
	foreach item $sorted {
		set item [::ymhuk::filt $item]
		if {$i == $last} {break}
		set item [split $item " "]
		set user [join [lindex $item 0]]
		set remort [::ymhuk::get.remort $user]
		if {$remort >= $conf(r.choose)} {
			append sorted_color "[expr $i + 1].\0034 $conf(choose.type.chan)$user\017 \0035 -\00313 [lindex $item 1]\0035 [lindex {0   } [::ymhuk::check.number [lindex $item 1]]].\0033 "
		} else {
			append sorted_color "[expr $i + 1].\0034 $user \0035 -\00313 [lindex $item 1]\0035 [lindex {0   } [::ymhuk::check.number [lindex $item 1]]].\0033 "
		}
		incr i
	}
	#  
	::ymhuk::pub.msg $sorted_color
	return
}

#  
proc ::ymhuk::top.answers {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {$chan != $conf(chan)} {
		return
	}
	#     
	set sorted [::ymhuk::sort.users 2]
	switch [catch {expr $text}] {
		0 { if {(0 < $text) && ($text < 11)} {set last $text} else {set last 5} }
		1 {	set last 5 }
	}
	set i 0
	#    
	set sorted_color "\00312  :\00312 "
	foreach item $sorted {
		set item [::ymhuk::filt $item]
		if {$i == $last} {break}
		set item [split $item " "]
		set user [join [lindex $item 0]]
		set remort [::ymhuk::get.remort $user]
		if {$remort >= $conf(r.choose)} {
			append sorted_color "[expr $i + 1].\0033 $conf(choose.type.chan)$user\017 \00310 -\0037 [lindex $item 2]\00310 [lindex {0   } [::ymhuk::check.number [lindex $item 2]]].\00312 "
		} else {
			append sorted_color "[expr $i + 1].\0033 $user \00310 -\0037 [lindex $item 2]\00310 [lindex {0   } [::ymhuk::check.number [lindex $item 2]]].\00312 "
		}
		incr i
	}
	#  
	::ymhuk::pub.msg $sorted_color
	return
}

#   (   )
proc ::ymhuk::filt {data} {
	regsub -all -- {\\} $data {\\\\} data
	return $data
}

################################
####         ####
################################

proc ::ymhuk::back.up.base {min hour day month year} {
	variable conf
	putlog "Backuping userbase..."
	set back_up ""
	# 
	set f [open $conf(back.up.base) w]
	fconfigure $f -encoding "binary"
	#      
	foreach user [userlist] {
		if {[getuser $user xtra ymhuk] == ""} {continue}
		set score 			[::ymhuk::get.score $user]
		set answers			[::ymhuk::get.answers $user]
		set answer_chain 	[::ymhuk::get.answer.chain $user]
		set seconds			[::ymhuk::get.seconds $user]
		set sex				[::ymhuk::sex.check $user]
		set news			[::ymhuk::get.news $user]
		set idle			[::ymhuk::get.idle $user]
		if {[::ymhuk::get.remort $user]} {set remort [::ymhuk::get.remort $user]} else {set remort "no"}
		if {[getuser $user xtra title] != ""} {set title [getuser $user xtra title]} else {set title "no"}
		set line "user:$user*score:$score*answers:$answers*answer_chain:$answer_chain*seconds:$seconds*sex:$sex*news:$news*idle:$idle*remort:$remort*title:$title"
		puts $f $line
	}
	#   
	close $f
	putlog "Done"
	return
}

proc ::ymhuk::del.old.players {min hour day month year} {
	variable conf
	set f [open $conf(old.players) a+]
	foreach user [userlist] {
		set no_del 0
		if {[getuser $user xtra ymhuk] == ""} {continue}
		if {[getuser $user xtra idle] == ""} {continue}
		foreach perm_user [split $conf(perm.users) ","] {
			if {$user == $perm_user} {
				set no_del 1
				break
			}
		}
		if {$no_del == 1} {continue}
		if {([expr [clock seconds] - [getuser $user xtra idle]]) > $conf(max.idle)} {
			set score 			[::ymhuk::get.score $user]
			set answers			[::ymhuk::get.answers $user]
			set answer_chain 	[::ymhuk::get.answer.chain $user]
			set seconds			[::ymhuk::get.seconds $user]
			set sex				[::ymhuk::sex.check $user]
			set news			[::ymhuk::get.news $user]
			set idle			[::ymhuk::get.idle $user]
			if {[::ymhuk::get.remort $user]} {set remort [::ymhuk::get.remort $user]} else {set remort "no"}
			if {[getuser $user xtra title] != ""} {set title [getuser $user xtra title]} else {set title "no"}
				set line "user:$user*score:$score*answers:$answers*answer_chain:$answer_chain*seconds:$seconds*sex:$sex*news:$news*idle:$idle*remort:$remort*title:$title"
			puts $f $line
			deluser $user
		}
	}
	close $f
	return
}

proc ::ymhuk::top.html {min hour day month year} {
	variable conf
	set t [expr int([clock format [clock seconds] -format %H])]
	#if {($t >= $conf(day)) && ($t <$conf(night))} {
	#	::ymhuk::day.top.html 
	#} else {
		::ymhuk::night.top.html 
	#}
	return
}

proc ::ymhuk::day.top.html {} {
	variable conf
	global botnick
	set f [open $conf(top.html) w]
	puts $f "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">"
	puts $f "<META http-equiv=Content-Type content=\"text/html; charset=windows-1251\">"
	puts $f "<HTML><HEAD><TITLE> </TITLE>"
	puts $f "<META content=\"MSHTML 6.00.2900.2180\" name=GENERATOR></HEAD><BODY BGCOLOR=#ffffff>"
	puts $f "<font FACE=courier new SIZE=5 COLOR=#00FF00><b><center>   $conf(channel)  $conf(net)</center></b></font><br><br>" 
	puts $f "<TABLE align=center cellSpacing=0 borderColorDark=#ffff00 cellPadding=1 width=\"80%\" borderColorLight=#ffffff border=1><TBODY><TR BGCOLOR=#FFFF66>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000> </font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000> </font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000><br><br> (.)</font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#000000></font></td><tr>"
	set i 1
	set sorted [::ymhuk::sort.users 1]
	foreach item $sorted {
		set user 			[lindex $item 0]
		set score 			[lindex $item 1]
		set answers 		[lindex $item 2]
		set answer_chain 	[lindex $item 3]
		set answer_time		[lindex $item 4]
		set title [::ymhuk::get.title.nick $user]
		switch "[getuser $user xtra sex]" {
			m {set sex ""}
			w {set sex ""}
			default {set sex ""}
		}
		if {[::ymhuk::get.remort $user]} { set remort [::ymhuk::get.remort $user] } else { set remort "-" }
		if {($score != "") && ($score != 0) && ($answers != "") && ($answers != 0)} {
			if {![::ymhuk::get.remort $user]} {
				set middle [expr 1.0 * $score / $answers]
			} else {
				set middle [expr ( 1.0 * ( $conf(remort.score) * $remort + $score )) / $answers]
			}
			if {[regexp -nocase -- {^(\d+)\.(\d{1,2})} $middle a middle b] } { set middle "$middle.$b"	}
		} else { set middle "-" }
		if {$score == ""} {set score "-"}; if {$answers == ""} {set answers "-"}; if {$answer_chain == ""} {set answer_chain "-"}; if {$answer_time == ""} {set answer_time "-"}
		switch "$conf(choose.type.top)" {
			"<b>" 		{ set close_teg "</b>" }
			"<u>" 		{ set close_teg "</u>" }
			"<b><u>"	{ set close_teg "</b></u>" }
			default		{ set close_teg "</b></u>" }
		}
		if {[expr $i % 2] != 0} {
			puts $f "<tr><td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF0000>$i</font></td>"
		} else {
			puts $f "<tr BGCOLOR=#FFFF99><td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF0000>$i</font></td>"
		}
		if {$remort >= $conf(r.choose)} {
			puts $f "<td ALIGN=center><font FACE=courier SIZE=3 COLOR=#CC33CC>$conf(choose.type.top)$user$close_teg</font></td>"
		} else {
			puts $f "<td ALIGN=center><font FACE=courier SIZE=3 COLOR=#CC33CC>$user</font></td>"
		}
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#3300FF><nobr>$title</nobr></font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#00FF33>$sex</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$score</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$answers</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$answer_chain</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$answer_time</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$middle</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#FF00CC>$remort</font></td></tr>"
		incr i
		if {$i > $conf(top.list)} {break}
	}
	puts $f "</TABLE><br><br>"
	puts $f "&nbsp&nbsp&nbsp&nbsp<font FACE=courier SIZE=2 COLOR=#00FF00>   : [llength $sorted]. : [expr $i - 1].</font><br><br>"
	puts $f "&nbsp&nbsp&nbsp&nbsp<font FACE=courier SIZE=2 COLOR=#FF0000> by $botnick on [ctime [unixtime]].</font>"
	puts $f "</body></html>"
	close $f
	return
}

proc ::ymhuk::night.top.html {} {
	variable conf
	global botnick
	set f [open $conf(top.html) w]
	puts $f "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">"
	puts $f "<META http-equiv=Content-Type content=\"text/html; charset=windows-1251\">"
	puts $f "<HTML><HEAD><TITLE> </TITLE>"
	puts $f "<META content=\"MSHTML 6.00.2900.2180\" name=GENERATOR></HEAD><BODY BGCOLOR=#000000 COLOR=#ffffff>"
	puts $f "<font FACE=courier new SIZE=5 COLOR=#00FF00><b><center>   $conf(channel)  $conf(net)</center></b></font><br><br>" 
	puts $f "<TABLE align=center cellSpacing=0 borderColorDark=#000000 cellPadding=1 width=\"80%\" borderColorLight=#cccccc border=1><TBODY><TR>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff> </font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff> </font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff><br><br> (.)</font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff><br></font></td>"
	puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#5555ff></font></td><tr>"
	set i 1
	set sorted [::ymhuk::sort.users 1]
	foreach item $sorted {
		set item [split $item " "]
		set user 			[lindex $item 0]
		#putlog "$user"
		set score 			[lindex $item 1]
		set answers 		[lindex $item 2]
		set answer_chain 	[lindex $item 3]
		set answer_time		[lindex $item 4]
		set title [::ymhuk::get.title.nick $user]
		switch "[getuser $user xtra sex]" {
			m {set sex ""}
			w {set sex ""}
			default {set sex ""}
		}
		if {[::ymhuk::get.remort $user]} { set remort [::ymhuk::get.remort $user] } else { set remort "-" }
		if {($score != "") && ($score != 0) && ($answers != "") && ($answers != 0)} {
			if {![::ymhuk::get.remort $user]} {
				set middle [expr 1.0 * $score / $answers]
			} else {
				set middle [expr ( 1.0 * ( $conf(remort.score) * $remort + $score )) / $answers]
			}
			if {[regexp -nocase -- {^(\d+)\.(\d{1,2})} $middle a middle b] } { set middle "$middle.$b"	}
		} else { set middle "-" }
		if {$score == ""} {set score "-"}; if {$answers == ""} {set answers "-"}; if {$answer_chain == ""} {set answer_chain "-"}; if {$answer_time == ""} {set answer_time "-"}
		switch "$conf(choose.type.top)" {
			"<b>" 		{ set close_teg "</b>" }
			"<u>" 		{ set close_teg "</u>" }
			"<b><u>"	{ set close_teg "</b></u>" }
			default		{ set close_teg "</b></u>" }
		}
		if {[expr $i % 2] != 0} {
			puts $f "<tr><td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff0000>$i</font></td>"
		} else {
			puts $f "<tr BGCOLOR=#333333><td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff0000>$i</font></td>"
		}
		if {$remort >= $conf(r.choose)} {
			puts $f "<td ALIGN=center><font FACE=courier SIZE=3 COLOR=#00FFFF>$conf(choose.type.top)$user$close_teg</font></td>"
		} else {
			puts $f "<td ALIGN=center><font FACE=courier SIZE=3 COLOR=#00FFFF>$user</font></td>"
		}
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#55ff55><nobr>$title</nobr></font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ffff33>$sex</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$score</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$answers</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$answer_chain</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$answer_time</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$middle</font></td>"
		puts $f "<td ALIGN=center><font FACE=courier SIZE=2 COLOR=#ff00ff>$remort</font></td></tr>"
		incr i
		if {$i > $conf(top.list)} {break}
	}
	puts $f "</TABLE><br><br>"
	puts $f "&nbsp&nbsp&nbsp&nbsp<font FACE=courier SIZE=2 COLOR=#00FF00>   : [llength $sorted]. : [expr $i - 1].</font><br><br>"
	puts $f "&nbsp&nbsp&nbsp&nbsp<font FACE=courier SIZE=2 COLOR=#0099CC> by $botnick on [ctime [unixtime]].</font>"
	puts $f "</body></html>"
	close $f
	return
}

proc ::ymhuk::ftp {min hour day month year} {
	variable conf
	if {!$conf(ftp)} {return}
	::ymhuk::sendftp $conf(top.html) $conf(ftp.host) $conf(ftp.login) $conf(ftp.pass) $conf(ftp.folder)
	return
}

proc ::ymhuk::sendftp { localfile server user pass remotefile } {
	variable conf
	if {![file exist $localfile]} {
		return "sendftp: File $localfile does not exist."
	}
	set pipe [open "|$conf(ftp.prog) -n $server" w]
	puts $pipe "user $user $pass"
	puts $pipe "bin"
	puts $pipe "put $localfile $remotefile"
	puts $pipe "quit"
	close $pipe
	return 1
}

#################################################
#################################################
####            ####
#################################################
#################################################


#####################################################################
####     !  ! -       ####
#####################################################################



# ! <>,   ! (  )
proc ::ymhuk::won {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {$chan != $conf(chan)} {
		return
	}
	#   !,     
	if {$text == ""} {
		#  ,        ,   
		switch [::ymhuk::check.user $nick] {
			1 {
				set score 			[::ymhuk::get.score $nick]
				set answers 		[::ymhuk::get.answers $nick]
				set answer_chain 	[::ymhuk::get.answer.chain $nick]
				set seconds 		[::ymhuk::get.seconds $nick]
				set user_place 		[::ymhuk::user.place $nick]
				set diference 		[::ymhuk::diference $nick]
				set title			[::ymhuk::get.title.nick $nick]
				set remort 			[::ymhuk::get.remort $nick]
				if {$diference == ""} {
					switch "$remort" {
						0 { ::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312." }
						default {
							if {$remort >= $conf(r.choose)} {
								::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$nick\017 \00312\[\00313$title\00312\]: :\00313 $remort\00312, :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
							} else {
								::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
							}
						}
					}
				} else {
					switch "$remort" {
						0 { ::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312." }
						default {
							if {$remort >= $conf(r.choose)} {
								::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$nick\017 \00312\[\00313$title\00312\]: :\00313 $remort\00312, :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312."
							} else {
								::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312."
							}
						}
					}
				}	
			}
			0 {::ymhuk::pub.msg "\00312     \00310 $nick\00312."}
		}
	#   
	} else {
		#    ,        ,   
		switch [::ymhuk::check.user $text] {
			1 {
				set score 			[::ymhuk::get.score $text]
				set answers 		[::ymhuk::get.answers $text]
				set answer_chain 	[::ymhuk::get.answer.chain $text]
				set seconds 		[::ymhuk::get.seconds $text]
				set user_place 		[::ymhuk::user.place $text]
				set diference 		[::ymhuk::diference $text]
				set title 			[::ymhuk::get.title.nick $text]
				set remort			[::ymhuk::get.remort $text]
				if {$diference == ""} {
					switch "$remort" {
						0 { ::ymhuk::pub.msg "\00312\00310 $text \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312." }
						default {
							if {$remort >= $conf(r.choose)} {
								::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$text\017 \00312\[\00313$title\00312\]: :\00313 $remort\00312, :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
							} else {
								::ymhuk::pub.msg "\00312\00310 $text \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
							}
						}
					}
				} else {
					switch "$remort" {
						0 { ::ymhuk::pub.msg "\00312\00310 $text \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312." }
						default {
							if {$remort >= $conf(r.choose)} {
								::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$text\017 \00312\[\00313$title\00312\]: :\00313 $remort\00312, :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312."
							} else {
								::ymhuk::pub.msg "\00312\00310 $text \00312\[\00313$title\00312\]: :\00313 $user_place\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312,    :\00313 $diference\00312."
							}
						}
					}
				}	
			}
			0 {::ymhuk::pub.msg "\00312     \00310 $text\00312."}
		}
	}
	return
}

# ! <>,   ! (  )
proc ::ymhuk::place {nick uhost handle chan text} {
	variable conf; variable ymhuk
	# 
	if {$chan != $conf(chan)} {
		return
	}
	#   
	set sorted [::ymhuk::sort.users 1]
	#  ,    ,  ,  
	switch [catch {expr $text}] {
		0 { 
			if {(0 < $text) && ($text <= [llength $sorted])} {
				set user 			[lindex $sorted [expr $text - 1] 0]
				set score 			[lindex $sorted [expr $text - 1] 1]
				set answers 		[lindex $sorted [expr $text - 1] 2]
				set answer_chain 	[lindex $sorted [expr $text - 1] 3]
				set seconds 		[lindex $sorted [expr $text - 1] 4]
				set title 			[::ymhuk::get.title.place $text]
				set remort			[::ymhuk::get.remort $user]
				switch "$remort" {
					0 { ::ymhuk::pub.msg "\00312\00310 $user \00312\[\00313$title\00312\]: :\00313 $text\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312." }
					default {
						if {$remort >= $conf(r.choose)} {
							::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$user\017 \00312\[\00313$title\00312\]: : \00313$remort\00312, :\00313 $text\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
						} else {
							::ymhuk::pub.msg "\00312\00310 $user \00312\[\00313$title\00312\]: : \00313$remort\00312, :\00313 $text\00312, :\00313 $score\00312,  :\00313 $answers\00312,   :\00313 $seconds\00312 ,    :\00313 $answer_chain\00312."
						}
					}
				}
			} else {
				::ymhuk::pub.msg "\00312  !"
			}
		}
		1 {
			if {$text == ""} {
				::ymhuk::won $nick $uhost $handle $chan $text
				return
			}
			::ymhuk::pub.msg "\00312  !" 
		}
	}
	return
}

proc ::ymhuk::show.titles {nick uhodt handle text} {
	variable conf
	::ymhuk::priv.msg $nick "\00312|        \00310\00312          | \00310.  \00312 |"
	::ymhuk::priv.msg $nick "\00312______________________________________"
	::ymhuk::priv.msg $nick "\00310$conf(no.title)   \00312-     \00313-|-"
	::ymhuk::priv.msg $nick "\00310[lindex $conf(man.titles) 0]   \00312-  \00313 0"
	set i 0
	foreach item $conf(man.titles) {
		if {$i == 0} {incr i; continue}
		::ymhuk::priv.msg $nick "\00310$item   \00312-\00313   [lindex $conf(title.score) [expr $i - 1]]"
		incr i
	}
	::ymhuk::priv.msg $nick "\00310$conf(man.max.title)   \00312-\00313   [lindex $conf(title.score) [expr $i - 1]]"
	::ymhuk::priv.msg $nick "\00312______________________________________"
	::ymhuk::priv.msg $nick "\00310   ."
	return
}

###########################################
####     !  !    ####
###########################################

#   " "
proc ::ymhuk::main.next {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,    ,    
	if {($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	}
	switch "$ymhuk(game.type)" {
		1 {
			if {![::ymhuk::plain.next $nick]} {return}
		}
		2 {
			if {![::ymhuk::anagramm.next $nick]} {return}
		}
		3 {
			if {![::ymhuk::sharads.next $nick]} {return}
		}
		4 {
			if {![::ymhuk::cat.next $nick]} {return}
		}
		5 {
			if {![::ymhuk::blitz.next $nick]} {return}
		}
	}
	::ymhuk::kill.timers
	utimer 5 [ list ::ymhuk::main $nick $uhost $handle $chan $text]
	return
}

#   
proc ::ymhuk::main.question {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,    ,  
	if {($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	} 
	#  ,   
	switch "$ymhuk(game.type)" {
		1 {
			::ymhuk::plain.question $nick
		}
		2 {
			::ymhuk::anagramm.question $nick
		}
		3 {
			::ymhuk::sharads.question $nick
		}
		4 {
			::ymhuk::cat.question $nick
		}
		5 {
			::ymhuk::blitz.question $nick
		}
	}
	return
}


########################################################
####            ####
########################################################

proc ::ymhuk::joins.chan {nick uhost handle chan} {
	variable conf; variable ymhuk
	# ,   ,   ,     
	if {([isbotnick $nick]) || ($chan != $conf(chan))} {
		return
	}
	set title [::ymhuk::get.title.nick $nick]
	if {(![::ymhuk::check.user $nick])} {
		::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]."
		return
	}
	# ,  
	if {$conf(news.allow) == 1} {
		::ymhuk::news.on.join $nick
	}
	#   
	set score 	[::ymhuk::get.score $nick]
	set place 	[::ymhuk::user.place $nick]
	set remort [::ymhuk::get.remort $nick]
	#  
	switch "$remort" {
		0 { ::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: :\00313 $place\00312, :\00313 $score\00312." }
		default {
			if {$remort >= $conf(r.choose)} {
				::ymhuk::pub.msg "\00312\00310 $conf(choose.type.chan)$nick\017 \00312\[\00313$title\00312\]: : \00313$remort\00312, :\00313 $place\00312, :\00313 $score\00312."
			} else {
				::ymhuk::pub.msg "\00312\00310 $nick \00312\[\00313$title\00312\]: : \00313$remort\00312, :\00313 $place\00312, :\00313 $score\00312."
			}
		}
	}
	if {![info exists ymhuk(game)]} {
		::ymhuk::notice $nick "     .  !  ."
	}
	set sex 	[::ymhuk::sex.check $nick]
	if {($sex != "m") && ($sex != "w")} {				
		::ymhuk::priv.msg $nick "\00312  !  \00310 !sex m\00312     \00310 !sex w\00312   ."
	}
	#  ,   
	if {($conf(places1) > 0) && ($place <= $conf(places1))} {
		pushmode $conf(chan) +$conf(flag1) $nick
		return
	}
	if {($conf(places2) > 0) && ($place <= $conf(places2))} {
		pushmode $conf(chan) +$conf(flag2) $nick
		return
	}
	if {($conf(places3) > 0) && ($place <= $conf(places3))} {
		pushmode $conf(chan) +$conf(flag3) $nick
		return
	}
	return
}


#########################################
####            ####
#########################################

proc ::ymhuk::timers {nick uhost handle chan text} {
	#   
	foreach u [utimers] {
		::ymhuk::priv.msg $nick "$u"
	}
	return
}

#   
proc ::ymhuk::kill.timers {} {
	#   
	foreach u [utimers] {
		if {[string match -nocase "*ymhuk*" [lindex $u 1]]} {
			killutimer [lindex $u 2]
		}
	}
	return
}

######################################
####         ####
######################################

#     
proc ::ymhuk::convert.word.single {text} {
	#   
	set firstsymbol [string index $text 0]
	#    "*"
	regsub -all -- {.} $text {*} hintstring
	#     
	regsub -all -- {^.} $hintstring [append firstsymbol "\00313"] hintstring
	return $hintstring
	#  ,    -  
}

#     
proc ::ymhuk::convert.word.double {text} {
	set double [string range $text 0 1]
	#    "*"
	regsub -all -- {.} $text {*} hintstring
	# 2    2  
	regsub -all -- {^.?.} $hintstring [append double "\00313"] hintstring
	return $hintstring
}	

#     
proc ::ymhuk::convert.word.trio {text} {
	set trio [string range $text 0 2]
	#    "*"
	regsub -all -- {.} $text {*} hintstring
	# 3    3  
	regsub -all -- {^.?.?.} $hintstring [append trio "\00313"] hintstring
	return $hintstring
}	


##############################
####         ####
##############################

#   (   )
proc ::ymhuk::filter {text} {
	variable ymhuk
	set ymhuk(answer) [string trim [string map {    ` \'} $ymhuk(answer)]]
	#   
	set text [string map {    ` \'} $text]
	#  
	regsub -all {[;:()\[\]!?.,/\\{}]} [::egglib::tolower $text] "" text;
	return [string trim $text]
}

#  
proc ::ymhuk::check.number {number} { switch -glob -- "$number" { *11 {return 3} *12 {return 3} *13 {return 3} *14 {return 3} *1 {return 1} *2 {return 2} *3 {return 2} *4 {return 2} default {return 3} } }

#
bind msg -|- !vhelp ::ymhuk::vhelp
bind msg -|- !ahelp ::ymhuk::ahelp
bind msg -|- !shelp ::ymhuk::shelp
bind msg -|- !chelp ::ymhuk::chelp
bind msg -|- !bhelp ::ymhuk::bhelp

bind msg -|- !comhelp 	::ymhuk::comhelp
bind msg -|- !rhelp 	::ymhuk::rhelp
bind msg -|- !newshelp 	::ymhuk::newshelp
bind msg -|- !ehelp 	::ymhuk::ehelp

proc ::ymhuk::vhelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\0035   ,       .   ,   .     .         .     \0033!\0035,  \0033!\0035     \0033!!\0035,  \0033!!\0035  ."
	::ymhuk::priv.msg $nick "\0035,       ,         ."
	return
}

proc ::ymhuk::ahelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\0034       ,     .     ,        ,      ."
	::ymhuk::priv.msg $nick "\0034            -   ,   .   (\0033!\0034, \0033!\0034,\0033!!\0034, \0033!!\0034)      , ,    ,    \0033 20\0034   ."
	return
}

proc ::ymhuk::shelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\0037    ,       ,   .      ,         ,  ,      .          ,     .  ,   ,             ."
	::ymhuk::priv.msg $nick "\0037     ,     ,      .         \0033!\0037,  \0033!\0037     \0033!!\0037,  \0033!!\0037  ,       ."
	return
}

proc ::ymhuk::chelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\00312\"  \" -    ,   ,   .      , , ,      .  -    ,   ,  ,     ."
	::ymhuk::priv.msg $nick "\00312  ,  ,    ,     .   ,      -     ,  ,        .         .  ."
	return
}

proc ::ymhuk::bhelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\00310-  ,         .   ,   ,      . ,          ,    .   -  ."
	return
}

proc ::ymhuk::comhelp {nick uhost handle text} {
	::ymhuk::priv.msg $nick "\037\00312 :\017\00313 !\00312 -  , \00313!\00312 -  , \00313!\00312 -   , \00313!!\00312 -   , \00313!\00312 -    , \00313!\00312 -   , \00313! \[\]\00312 -    (       );"
	::ymhuk::priv.msg $nick "\037\00312 :\017\00313 ! \[\]\00312 -     (       ), \00313!\00312 -   , \00313!\00312 -   , \00313!\00312 -   , \00313!\00312 -   , \00313!\00312 -   .   ."
	return
}

proc ::ymhuk::rhelp {nick uhost handle text} {
	variable conf
	::ymhuk::priv.msg $nick "\037\00312:\017\00312        .        \00313!\00312.    ,      .      \00313!sex m\00312    \00313!sex w\00312  ."
	::ymhuk::priv.msg $nick "\037\00312:\017\00312  -  .     \00313 $conf(remort.score)\00312 .     ,      \00313!\00312.      \00313!\00312.     :   ,    \00313!\00312  \00313!\00312,   .     \00313! <>\00312."
	return
}

proc ::ymhuk::newshelp {nick uhost handle text} {
	variable conf
	::ymhuk::priv.msg $nick "\037\00312:\017\00312        - .       \00313! <>\00312.        \00313!\00312  .          . ,       ,     ,   ."
	::ymhuk::priv.msg $nick "\037\00312:\017\00312       .     \00313! < >\00312.      \00313! <>\00312.      ,    ."
	return
}

proc ::ymhuk::ehelp {nick uhost handle text} {
	variable conf
	set adm ""
	foreach item [split $conf(admin) ","] {
		append adm "\00313$item\00312, " 
	}
	set l [string length $adm]
	set adm [string replace $adm [expr $l - 2] $l]
	::ymhuk::priv.msg $nick "\037\00312 :\017\00312    ,      ,      ,     .   html-  . ,    ,     ."
	::ymhuk::priv.msg $nick "\037\00312 :\017\00312 $adm."
	return
}

# 
proc ::ymhuk::help {nick uhost handle chan text} {
	variable conf
	if {($chan != $conf(chan))} {
		return
	}
	::ymhuk::priv.msg $nick "\002\00312  \0037\0033yMHuk\00312:"
	::ymhuk::priv.msg $nick "\00312   .    ,       ."
	set i 1
	if {$conf(viktorina)} {
		::ymhuk::priv.msg $nick "\002\0035 $i.  .\017 (        \0035!vhelp\017)"
		incr i
	}
	if {$conf(anagramm)} {
		::ymhuk::priv.msg $nick "\002\0034 $i. .\017 (        \0034!ahelp\017)"
		incr i
	}
	if {$conf(sharads)} {
		::ymhuk::priv.msg $nick "\002\0037 $i. .\017 (        \0037!shelp\017)"
		incr i
	}
	if {$conf(cat)} {
		::ymhuk::priv.msg $nick "\002\00312 $i.   .\017 (        \00312!chelp\017)"
		incr i
	}
	if {$conf(blitz)} {
		::ymhuk::priv.msg $nick "\002\00310 $i. -.\017 (        \00310!bhelp\017)"
	} 
	set news ""
	if {$conf(news.allow)} {
		set news "\00313!newshelp\00312 -   , "
	}
	::ymhuk::priv.msg $nick "\037\00312  :\017 \00313!comhelp\00312 -   , \00313!rhelp\00312 -     , $news\00313!ehelp\00312 -    ."
	return
}

#
proc ::ymhuk::version {nick uhost handle chan text} {
	variable conf
	if {($chan != $conf(chan))} {
		return
	}
	::ymhuk::pub.msg "\00312  : $conf(ver)\00312."
	return
}

#   
proc ::ymhuk::stat {nick uhost handle chan text} {
	variable ymhuk; variable conf
	if {($chan != $conf(chan))} {
		return
	}
	set an ""
	::ymhuk::plain.initialization
	if {$conf(anagramm) == 1} {
		::ymhuk::anagramm.init
		set an "\00312   :\00313 $ymhuk(anagramm.base.length)\00312,   \00313 $ymhuk(anagramm.counter)\00312 ."
	}
	if {$ymhuk(baselength) == 0} {
		::ymhuk::pub.msg "\0034  !"
		return
	}
	::ymhuk::pub.msg "\00312 \00313 $ymhuk(baselength)\00312 [lindex {0   } [::ymhuk::check.number $ymhuk(baselength)]],    \00313 $ymhuk(q.counter)\00312 .$an"
	return
}

putlog "yMHuk: Main resorses loaded"