########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################



#######################################
#######################################
####           ####
#######################################
#######################################

#     
proc ::ymhuk::anagramm.init {} {
	variable conf; variable ymhuk
	#      ,      
	if {[getuser $conf(owner) xtra anagramm] == ""} {
		setuser $conf(owner) xtra anagramm 0
	}
	# -,      
	set ymhuk(anagramm.counter) [getuser $conf(owner) xtra anagramm]
	return
}

proc ::ymhuk::anagramm.load.base {} {
	variable conf; variable ymhuk
	::ymhuk::pub.msg "\00312  ,     ..."
	::ymhuk::anagramm.init
	set ymhuk(a.positons) ""
	catch {open $conf(anagramm.base) r} f
	while {![eof $f]} {
		set position [tell $f]
		set line [string trim [gets $f]]
		lappend ymhuk(a.positions) $position
	}
	close $f
	set ymhuk(anagramm.base.length) [llength $ymhuk(a.positions)]
	switch "$conf(a.random.type)" {
		1 {
			if {($ymhuk(anagramm.counter) > ([expr [llength $ymhuk(a.positions)] - 1]))} { set ymhuk(anagramm.counter) 0 }
			set ymhuk(a.positions) [lreplace $ymhuk(a.positions) 0 [expr $ymhuk(anagramm.counter) - 1]]
		}
		0 {}
	}
	return
}

proc ::ymhuk::anagramm.sql.load.base {} {
	variable conf; variable ymhuk
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from anagramms;"]
	set ymhuk(anagramm.base.length) [::mysql::fetch $q]
	::mysql::endquery $q
	switch "$conf(a.random.type)" {
		1 {
			set q [::mysql::query $ymhuk(sql.con) "select a_counter from counters where id = 1;"]
			set ymhuk(anagramm.counter) [::mysql::fetch $q]
			::mysql::endquery $q
			if {$ymhuk(anagramm.counter) > $ymhuk(anagramm.base.length)} {
				set ymhuk(anagramm.counter) 1
				::mysql::exec $ymhuk(sql.con) "update counters set a_counter = $ymhuk(anagramm.counter) where id = 1;"
			}
		}
		0 {}
	}
	return
}

################################################
################################################
####            ####
################################################
################################################

#  
proc ::ymhuk::anagramm.out {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$conf(sql.enable)" {
		0 {
			if {![info exists ymhuk(a.positions)] || ![llength $ymhuk(a.positions)]} {
				::ymhuk::anagramm.load.base
			}
			switch "$conf(a.random.type)" {
				1 {	
					catch {open $conf(anagramm.base) r} f
					seek $f [lindex $ymhuk(a.positions) 0]
					set ymhuk(a.data) [gets $f]
					close $f
					set ymhuk(a.positions) [lreplace $ymhuk(a.positions) 0 0]
					incr ymhuk(anagramm.counter)
					setuser $conf(owner) xtra anagramm $ymhuk(anagramm.counter)
					set number $ymhuk(anagramm.counter)
				}
				0 {
					catch {open $conf(anagramm.base) r} f
					set i [expr int(rand() * [expr [llength $ymhuk(a.positions)] - 1])]
					seek $f [lindex $ymhuk(a.positions) $i]
					set ymhuk(a.data) [gets $f]
					close $f
					set ymhuk(a.positions) [lreplace $ymhuk(a.positions) $i $i]
				}
			}
			#  
			set ymhuk(answer) $ymhuk(a.data)
		}
		1 {
			if {![::ymhuk::sql.ping]} {
				putlog "\0034    !    ."
				::ymhuk::kill.timers
				unset ymhuk(game)
				return
			}
			if {![info exists ymhuk(anagramm.base.length)]} {
				::ymhuk::anagramm.sql.load.base
			}
			switch "$conf(a.random.type)" {
				0 {	
					set i [expr int(rand() * $ymhuk(anagramm.base.length)) + 1]
					set q [::mysql::query $ymhuk(sql.con) "select anagramm from anagramms where id = $i;"]
					set raw [::mysql::fetch $q]
					set ymhuk(answer) $raw
					::mysql::endquery $q
				}
				1 {
					if {$ymhuk(anagramm.counter) > $ymhuk(anagramm.base.length)} {
						set ymhuk(anagramm.counter) 1
					}
					set q [::mysql::query $ymhuk(sql.con) "select anagramm from anagramms where id = $ymhuk(anagramm.counter);"]
					set raw [::mysql::fetch $q]
					set ymhuk(answer) $raw
					::mysql::endquery $q
					set number $ymhuk(anagramm.counter)
					incr ymhuk(anagramm.counter)
					::mysql::exec $ymhuk(sql.con) "update counters set a_counter = $ymhuk(anagramm.counter);"
				}
			}
		}
	}
	#   
	set ymhuk(round) 1
	# 
	set ymhuk(anagramm.question) [::ymhuk::anagramm.form]
	switch "$conf(a.random.type)" {
		1 {
			::ymhuk::pub.msg "\0034\037\017 \0034$number:\0033 $ymhuk(anagramm.question)."
		}
		0 {
			::ymhuk::pub.msg "\0034\037\017\0034:\0033 $ymhuk(anagramm.question)."
		}
	}
	#   
	set ymhuk(start.sec) [clock seconds]
	set ymhuk(start.ms) [clock click -milliseconds]
	#    (      " ")
	utimer $conf(anagramm.roundtime) [list ::ymhuk::anagramm.no.answer $nick $uhost $handle $chan $text]
	#  
	if {[string length $ymhuk(answer)] > 10} {
		set ymhuk(bonus) $conf(anagramm.extra.length)
	} else {
		set ymhuk(bonus) [lindex $conf(anagramm.answer.points) [string length $ymhuk(answer)]]
	}
	#     
	set ymhuk(hint2.allow)	0
	set ymhuk(need.hint2)	0
	# ,      ,     
	set ymhuk(got.hint1) 	0
	set ymhuk(got.hint2) 	0
	#    
	utimer $conf(anagramm.hint2.allow) [list ::ymhuk::anagramm.hint2]
	return
}

proc ::ymhuk::anagramm.form {} {
	variable ymhuk
	set anagramm_word $ymhuk(answer)
	while {$anagramm_word == $ymhuk(answer)} {
		set line [split $ymhuk(answer) ""]
		set anagramm_word ""
		while {[llength $line] != 0} {
			set r [rand [llength $line]]
			append anagramm_word [lindex $line $r]
			set line [lreplace $line $r $r]
		}
	}
	return $anagramm_word
}

#################################################
#################################################
####            ####
#################################################
#################################################

#    
proc ::ymhuk::anagramm.no.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,  -  ,   
	incr ymhuk(no.answer)
	#  
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	# 
	switch "$conf(anagramm.show.answer)" {
		1 {::ymhuk::pub.msg "\0034   .  :\0033 $ymhuk(answer)\0034.  ."}
		0 {::ymhuk::pub.msg "\0034    .  ."}
	}
	#      , 
	if {[::ymhuk::self.stop] == 1} { return }
	# 
	set ymhuk(round) 0
	#    
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
}


#######################################
#######################################
####           ####
#######################################
#######################################

proc ::ymhuk::anagramm.output {nick} {
	variable conf; variable ymhuk
	# 
	switch "$conf(anagramm.right.answer)" {
		1 {::ymhuk::pub.msg "\0034,\00313 $nick\0034!  :\0033 $ymhuk(answer)\0034.   \00312 $ymhuk(answer.time) \0034."}
		0 {::ymhuk::pub.msg "\0034,\00313 $nick\0034!   !   \00312 $ymhuk(answer.time) \0034."}
	}
	#  
	::ymhuk::increase.on.answer $nick
	#C       
	set points [::ymhuk::get.score $nick]
	#  " --..."
	::ymhuk::pub.msg "\0034!   \00313 $nick\0034 \0035 $ymhuk(bonus)\0034 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \0033 $points\0034 [lindex {0   } [::ymhuk::check.number $points]]."
	# ,      5  ,   
	if {[expr $ymhuk(answer.chain) % 5] == 0} {
		set lst " $nick ,\00313 $nick\003  ,\00312 $nick\003,\00312 $nick\003    , \00312 $nick\003  "
		# 10   -  ( -  )
		if {[expr $ymhuk(answer.chain) % 10] == 0} {
			set ymhuk(bonus) $ymhuk(answer.chain)
			#   
			::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]   \0034 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]!"
			::ymhuk::increase.on.answer $nick
			return
		}
		#  -    10,   5,   
		::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]] !"
		return
	}
	return
}

proc ::ymhuk::anagramm.out.change.place {nick} {
	variable ymhuk
	#     (   /  )
	if {$ymhuk(place.before) > $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0034!\00313 $nick\0034  \00313 $ymhuk(place.after)\0034 !"
		return
	}
	#     
	if {$ymhuk(place.before) < $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0034 ,\00313 $nick\0034  \00313 $ymhuk(place.after)\0034 !"
		return
	}
	return
}

proc ::ymhuk::anagramm.next {nick} {
	variable conf; variable ymhuk
	set let [::ymhuk::command.let $nick]
	#        
	if {(([::ymhuk::check.user $nick] == 0) || ([::ymhuk::user.place $nick] > $conf(command.places))) && !$let} {
		#    
		::ymhuk::pub.msg "\0034     !?"
		return 0
	}
	#  
	set ymhuk(answered.nick) 	""
	set ymhuk(answer.chain) 	1
	# 
	set ymhuk(round) 0
	# 
	switch "$conf(anagramm.next.answer)" {
		1 {::ymhuk::pub.msg "\0034  :\0033 $ymhuk(answer)\0034.  ."}
		0 {::ymhuk::pub.msg "\0034 !  ."}
	}
	return 1
}

proc ::ymhuk::anagramm.question {nick} {
	variable ymhuk
	::ymhuk::notice $nick ": $ymhuk(anagramm.question)."
	return
}


#########################
####        ####
#########################

# 
proc ::ymhuk::anagramm.hint1 {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {($conf(anagramm.hint) == 0) || ($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	}
	#   " "
	if {$conf(anagramm.decrease.points) == 1} {
		set decrease [expr round([expr $ymhuk(bonus) * $conf(anagramm.decr.user.points.h1)])]
		# ,             
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $decrease)} {
			# ,    
			::ymhuk::pub.msg "\00313$nick\0034, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
		#   ,    
		if {($ymhuk(got.hint1) == 1) || ($ymhuk(got.hint2) == 1)} {
			::ymhuk::pub.msg "\0034 ,  !"
			return
		}
	}
	set ymhuk(hint1) ""
	#      
	if {[string length $ymhuk(answer)] <=3} {
		::ymhuk::pub.msg "\0034  !"
		return
	} 
	#  
	set ymhuk(hint1) [::ymhuk::convert.word.single $ymhuk(answer)]
	#  
	switch "$conf(anagramm.decrease.points)" {
		1 {
			set ymhuk(got.hint1) 1
			::ymhuk::pub.msg "\0034\00313 $nick\0034   \0033 $decrease\0034 [lindex {0   } [::ymhuk::check.number $decrease]]!"
			::ymhuk::pub.msg "\0034:\003 $ymhuk(hint1)"
			::ymhuk::decrease $nick $decrease
		}
		0 { set ymhuk(bonus) [expr round([expr $ymhuk(bonus) * $conf(anagramm.points.after.h1)])]
			::ymhuk::pub.msg "\0034:\003 $ymhuk(hint1)"
		}
	}
	return
}

#     
proc ::ymhuk::anagramm.hint2 {} {
	variable conf; variable ymhuk
	#  ,   ,      , 
	if {($conf(anagramm.hint) == 0) || ($ymhuk(round) == 0) || ($ymhuk(need.hint2) == 0)} {
		#   
		set ymhuk(hint2.allow) 1
		set ymhuk(need.hint2) 1
		return
	}
	set ymhuk(hint2) ""
	#       
	switch -regexp -- "[string length $ymhuk(answer)]" {
		^1$ 		{::ymhuk::pub.msg "\0034  !"; return}
		^2$|^3$ 	{set ymhuk(hint2) [::ymhuk::convert.word.single $ymhuk(answer)]}
		^4$|^5$ 	{set ymhuk(hint2) [::ymhuk::convert.word.double $ymhuk(answer)]}
		default		{set ymhuk(hint2) [::ymhuk::convert.word.trio 	$ymhuk(answer)]}
	}
	#  
	switch "$conf(anagramm.decrease.points)" {
		1 {
			set ymhuk(got.hint2) 1
			::ymhuk::pub.msg "\0034\00313 $ymhuk(hint2.nick)\0034   \0033 $ymhuk(anagramm.h2.decreasing)\0034 [lindex {0   } [::ymhuk::check.number $ymhuk(anagramm.h2.decreasing)]]!"
			::ymhuk::pub.msg "\0034:\003 $ymhuk(hint2)"
			::ymhuk::decrease $ymhuk(hint2.nick) $ymhuk(anagramm.h2.decreasing)
		}
		0 { set ymhuk(bonus) [expr round([expr $ymhuk(bonus) * $conf(anagramm.points.after.h2)])]
			::ymhuk::pub.msg "\0034:\003 $ymhuk(hint2)"
		}
	}
	#  
	set ymhuk(hint2.allow) 1
	return
}

#    
proc ::ymhuk::anagramm.hint2.allow {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {($conf(anagramm.hint) == 0) || ($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	}
	if {$conf(anagramm.decrease.points) == 1} {
		set ymhuk(anagramm.h2.decreasing) [expr round([expr $ymhuk(bonus) * $conf(anagramm.decr.user.points.h2)])]
		if {$ymhuk(got.hint2) == 1} {
			::ymhuk::pub.msg "\0034 ,  !"
			return
		}
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $ymhuk(anagramm.h2.decreasing))} {
			::ymhuk::pub.msg "\00313$nick\0034, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
	}
	set ymhuk(hint2.nick) $nick
	#    ,  ,          
	if {$ymhuk(hint2.allow) == 0} {
		set hint2_seconds [::ymhuk::anagramm.hint2.seconds]
		# ,  
		switch "$conf(anagramm.decrease.points)" {
			1 { 
				set ymhuk(need.hint2) 1
				set ymhuk(got.hint2) 1
				::ymhuk::pub.msg "\0034    \0033 $ymhuk(anagramm.h2.decreasing)\0034 [lindex {0   } [::ymhuk::check.number $ymhuk(anagramm.h2.decreasing)]]!   \00312 $hint2_seconds\0034 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"	
				return
			}
			0 {
				set ymhuk(need.hint2) 1
				::ymhuk::pub.msg "\0034 !   \00312 $hint2_seconds\0034 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"
				return
			}
		}
	} else {
		#  ,   
		::ymhuk::anagramm.hint2
		return
	}
	return
}

#########################################
#########################################
####         ####
#########################################
#########################################


# - ,     
proc ::ymhuk::anagramm.hint2.seconds {} {
	foreach u [utimers] {
		#  
		if {[string match -nocase "*anagramm.hint2*" [lindex $u 1]]} {
			set hint2_seconds [lindex $u 0]
			
		}
	}
	# - 
	return $hint2_seconds
}


putlog "yMHuk: Anagramms script loaded"