########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################



#######################################
#######################################
####           ####
#######################################
#######################################


################################################
################################################
####            ####
################################################
################################################

#  
proc ::ymhuk::blitz.out.questions {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$conf(sql.enable)" {
		0 {
			if {![info exists ymhuk(q.positions)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			switch "$conf(random.type)" {
				1 {	
					catch {open $conf(questions) r} f
					seek $f [lindex $ymhuk(q.positions) 0]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) 0 0]
					incr ymhuk(q.counter)
					setuser $conf(owner) xtra counter $ymhuk(q.counter)
					set number [expr $ymhuk(q.counter)]
				}
				0 {
					catch {open $conf(questions) r} f
					set i [expr int(rand() * [expr [llength $ymhuk(q.positions)] - 1])]
					seek $f [lindex $ymhuk(q.positions) $i]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) $i $i]
				}
			}
		#  "|"    
		foreach {ymhuk(question) ymhuk(answer)} [split $ymhuk(q.data) "|"] {break}
		}
		1 {
			if {![::ymhuk::sql.ping]} {
				putlog "\0034    !    ."
				::ymhuk::kill.timers
				unset ymhuk(game)
				return
			}
			if {![info exists ymhuk(baselength)]} {
				::ymhuk::plain.sql.load.base
			}
			switch "$conf(random.type)" {
				0 {
					set i [expr int(rand() * $ymhuk(baselength)) + 1]
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $i;"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
				}
				1 {
					if {$ymhuk(q.counter) > $ymhuk(baselength)} {
						set ymhuk(q.counter) 1
					}
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $ymhuk(q.counter);"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
					set number $ymhuk(q.counter)
					incr ymhuk(q.counter)
					::mysql::exec $ymhuk(sql.con) "update counters set q_counter = $ymhuk(q.counter);"
				}
			}
		}
	}
	# -   
	set ymhuk(q.words) [llength [split $ymhuk(answer) " "]]
	#   
	set ymhuk(round) 1
	# 
	switch "$conf(random.type)" {
		1 {
			::ymhuk::pub.msg "\0037\037-\017 \0037$ymhuk(q.counter):\00310 $ymhuk(question) ([::ymhuk::blitz.form.letters $ymhuk(answer)])"
		}
		0 {
			::ymhuk::pub.msg "\0037\037-\017\0037:\00310 $ymhuk(question) ([::ymhuk::blitz.form.letters $ymhuk(answer)])"
		}
	}
	#  
	set ymhuk(bonus) $conf(blitz.answer.points)
	#   
	set ymhuk(start.sec) [clock seconds]
	set ymhuk(start.ms) [clock click -milliseconds]
	#    (      " ")
	utimer $conf(blitz.roundtime) [list ::ymhuk::blitz.no.answer $nick $uhost $handle $chan $text]
	return
}

#################################################
#################################################
####            ####
#################################################
#################################################

#    
proc ::ymhuk::blitz.no.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,  -  ,   
	incr ymhuk(no.answer)
	#  
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	# 
	switch "$conf(show.answer)" {
		1 {::ymhuk::pub.msg "\0037 ,  :\00310 $ymhuk(answer)\0037.   \0033 5 \0037."}
		0 {::ymhuk::pub.msg "\0037 .   \0033 5 \0037."}
	}
	#      , 
	if {[::ymhuk::self.stop] == 1} { return }
	# 
	set ymhuk(round) 0
	#    
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
}


#######################################
#######################################
####           ####
#######################################
#######################################

proc ::ymhuk::blitz.output {nick} {
	variable conf; variable ymhuk
	# 
	switch "$conf(right.answer)" {
		1 {::ymhuk::pub.msg "\0037,\00310 $nick\0037!  :\0033 $ymhuk(answer)\0037.   \0033 $ymhuk(answer.time) \0037."}
		0 {::ymhuk::pub.msg "\0037,\00310 $nick\0037!   !   \0033 $ymhuk(answer.time) \0037."}
	}
	#  
	::ymhuk::increase.on.answer $nick
	#C       
	set points [::ymhuk::get.score $nick]
	#  " --..."
	::ymhuk::pub.msg "\0037!\00310 $nick\0037 \0033 $ymhuk(bonus)\0037 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \0033 $points\0037 [lindex {0   } [::ymhuk::check.number $points]]."
	# ,      5  ,   
	if {[expr $ymhuk(answer.chain) % 5] == 0} {
		set lst " $nick ,\00313 $nick\003  ,\00312 $nick\003,\00312 $nick\003    , \00312 $nick\003  "
		# 10   -  ( -  )
		if {[expr $ymhuk(answer.chain) % 10] == 0} {
			set ymhuk(bonus) $ymhuk(answer.chain)
			#   
			::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]   \0034 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]!"
			::ymhuk::increase.on.answer $nick
			return
		}
		#  -    10,   5,   
		::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]] !"
		return
	}
	return
}

proc ::ymhuk::blitz.out.change.place {nick} {
	variable ymhuk
	#     (   /  )
	if {$ymhuk(place.before) > $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0037!\00310 $nick\0037  \0033 $ymhuk(place.after)\0037 !"
		return
	}
	#     
	if {$ymhuk(place.before) < $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0037 ,\00310 $nick\0037  \0033 $ymhuk(place.after)\0037 !"
		return
	}
	return
}

proc ::ymhuk::blitz.next {nick} {
	variable conf; variable ymhuk
	set let [::ymhuk::command.let $nick]
	#        
	if {(([::ymhuk::check.user $nick] == 0) || ([::ymhuk::user.place $nick] > $conf(command.places))) && !$let} {
		#    
		::ymhuk::pub.msg "\0037 !"
		return 0
	}
	#  
	set ymhuk(answered.nick) 	""
	set ymhuk(answer.chain) 	1
	# 
	set ymhuk(round) 0
	# 
	switch "$conf(next.answer)" {
		1 {::ymhuk::pub.msg "\0037 :\00310 $ymhuk(answer)\0037.   \0033 5\0037 ."}
		0 {::ymhuk::pub.msg "\0037  !   \0033 5\0037 ."}
	}
	return 1
}

proc ::ymhuk::blitz.question {nick} {
	variable ymhuk
	::ymhuk::notice $nick "-: $ymhuk(question)."
	return
}

#########################################
#########################################
####         ####
#########################################
#########################################


# - ,     
proc ::ymhuk::hint2.seconds {} {
	foreach u [utimers] {
		#  
		if {[string match -nocase "*hint2*" [lindex $u 1]]} {
			set hint2_seconds [lindex $u 0]
			
		}
	}
	# - 
	return $hint2_seconds
}

###########################################
####          ####  
###########################################

#          
proc ::ymhuk::blitz.form.letters {text} {
	variable ymhuk
	#
	set letters [string length $ymhuk(answer)]
	#
	set words [llength [split $ymhuk(answer) " "]]
	# 
	set out_string "\0033 $letters \0037[lindex {0   } [::ymhuk::check.number $letters]],\0033 $words \0037[lindex {0   } [::ymhuk::check.number $words]] \00310"
	return $out_string
}

putlog "yMHuk: Blitz script loaded"
