########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################



#######################################
#######################################
####           ####
#######################################
#######################################

#      ,     ,      
#   

################################################
################################################
####            ####
################################################
################################################

#  
proc ::ymhuk::cat.out.questions {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$conf(sql.enable)" {
		0 {
			if {![info exists ymhuk(q.positions)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			switch "$conf(random.type)" {
				1 {	
					catch {open $conf(questions) r} f
					seek $f [lindex $ymhuk(q.positions) 0]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) 0 0]
					incr ymhuk(q.counter)
					setuser $conf(owner) xtra counter $ymhuk(q.counter)
					set number [expr $ymhuk(q.counter)]
				}
				0 {
					catch {open $conf(questions) r} f
					set i [expr int(rand() * [expr [llength $ymhuk(q.positions)] - 1])]
					seek $f [lindex $ymhuk(q.positions) $i]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) $i $i]
				}
			}
		#  "|"    
		foreach {ymhuk(question) ymhuk(answer)} [split $ymhuk(q.data) "|"] {break}
		}
		1 {
			if {![::ymhuk::sql.ping]} {
				putlog "\0034    !    ."
				::ymhuk::kill.timers
				unset ymhuk(game)
				return
			}
			if {![info exists ymhuk(baselength)]} {
				::ymhuk::plain.sql.load.base
			}
			switch "$conf(random.type)" {
				0 {
					set i [expr int(rand() * $ymhuk(baselength)) + 1]
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $i;"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
				}
				1 {
					if {$ymhuk(q.counter) > $ymhuk(baselength)} {
						set ymhuk(q.counter) 1
					}
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $ymhuk(q.counter);"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
					set number $ymhuk(q.counter)
					incr ymhuk(q.counter)
					::mysql::exec $ymhuk(sql.con) "update counters set q_counter = $ymhuk(q.counter);"
				}
			}
		}
	}
	# -   
	set ymhuk(q.words) [llength [split $ymhuk(answer) " "]]
	#   
	set ymhuk(round) 1
	# 
	::ymhuk::pub.msg "\0032\037  \017\0032:\00310 $ymhuk(question) ([::ymhuk::cat.form.letters $ymhuk(answer)])"
	#   
	set ymhuk(start.sec) [clock seconds]
	set ymhuk(start.ms) [clock click -milliseconds]
	#    (      " ")
	utimer $conf(cat.roundtime) [list ::ymhuk::cat.no.answer $nick $uhost $handle $chan $text]
	#    
	return
}

#################################################
#################################################
####            ####
#################################################
#################################################

#    
proc ::ymhuk::cat.no.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,  -  ,   
	incr ymhuk(no.answer)
	#  
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	# 
	switch "$conf(cat.show.answer)" {
		1 {::ymhuk::pub.msg "\0032     :\00310 $ymhuk(answer)\0032.   \00313 5 \0032."}
		0 {::ymhuk::pub.msg "\0032    .   \00313 5 \0032."}
	}
	#      , 
	if {[::ymhuk::self.stop] == 1} { return }
	# 
	set ymhuk(round) 0
	#    
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
}


#######################################
#######################################
####           ####
#######################################
#######################################

proc ::ymhuk::cat.output {nick} {
	variable conf; variable ymhuk
	# 
	switch "$conf(cat.right.answer)" {
		1 {::ymhuk::pub.msg "\0032,\00310 $nick\0032!   :\00310 $ymhuk(answer)\0032.   \00313 $ymhuk(answer.time) \0032."}
		0 {::ymhuk::pub.msg "\0032,\00310 $nick\0032!    !   \00313 $ymhuk(answer.time) \0032."}
	}
	# ,      5  ,   
	if {[expr $ymhuk(answer.chain) % 5] == 0} {
		set lst " $nick ,\00313 $nick\003  ,\00312 $nick\003,\00312 $nick\003    , \00312 $nick\003  "
		#  -    10,   5,   
		::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]] !"
	}
	set flag [expr int(rand() * 5)]
	switch "$flag" {
		2 {
			if {![::ymhuk::check.user $nick]} {
				::ymhuk::pub.msg "\0032    . ,    ."
				return
			}
			set $ymhuk(bonus) [expr int(rand() * [expr $conf(cat.min.points) + 1])]
			while {$ymhuk(bonus) == 0} {
				set $ymhuk(bonus) [expr int(rand() * [expr $conf(cat.min.points) + 1])]
			}
			set len [llength [userlist]]
			set user [lindex [userlist] [rand $len]]
			while {[getuser $user xtra ymhuk] == ""} {
				set user [lindex [userlist] [rand $len]]
			}
			if {$user == $nick} {
				::ymhuk::pub.msg "\0032    ,     ,        ."
				return
			} else {
				::ymhuk::pub.msg "\0032 ,\0034 $nick\0032   ,    \00310 $user\0032,    \0034 $nick\00313 $ymhuk(bonus)\0032 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \00310 $user\0032."
				::ymhuk::decrease $nick $ymhuk(bonus)
				::ymhuk::increase.on.answer $user
				return
			}
		}
		default {
			set unlucky ""
			set ymhuk(bonus) [expr int(rand() * [expr $conf(cat.max.points) + 1])]
			while {$ymhuk(bonus) == 0} {
				set ymhuk(bonus) [expr int(rand() * [expr $conf(cat.max.points) + 1])]
			}
			set user_list [::ymhuk::users.more.score $ymhuk(bonus)]
			if {![llength $user_list]} {
				set unlucky ""
			} else {
				set unlucky [lindex $user_list [rand [llength $user_list]]]
			}
			if {$unlucky == ""} {
				::ymhuk::pub.msg "\0032   ,    \00310 $nick\00313 $ymhuk(bonus)\0032 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]."
				::ymhuk::increase.on.answer $nick
				return
			} elseif {$unlucky == $nick} {
				::ymhuk::pub.msg "\0032    \00310 $unlucky\0032,     ,        ."
				return
			} else {
				::ymhuk::pub.msg "\0032  \0034 $unlucky\0032,    \00310 $nick\0032,    \0034 $unlucky\00313 $ymhuk(bonus)\0032 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \00310 $nick\0032." 
				::ymhuk::decrease $unlucky $ymhuk(bonus)
				::ymhuk::increase.on.answer $nick
				return
			}
		}
	}
	return
}

proc ::ymhuk::users.more.score {score} {
	variable conf; variable ymhuk
	set users ""
	foreach user [userlist] {
		if {[::ymhuk::get.score $user] >= $ymhuk(bonus)} {
			lappend users "$user"
		}
	}
	return $users
}

proc ::ymhuk::cat.out.change.place {nick} {
	variable ymhuk
	#     (   /  )
	if {$ymhuk(place.before) > $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0032 \00310 $nick\0032  \00313 $ymhuk(place.after)\0032 !"
		return
	}
	#     
	if {$ymhuk(place.before) < $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0032- \00310 $nick\0032  \00313 $ymhuk(place.after)\0032 !"
		return
	}
	return
}


proc ::ymhuk::cat.next {nick} {
	variable conf; variable ymhuk
	set let [::ymhuk::command.let $nick]
	#        
	if {(([::ymhuk::check.user $nick] == 0) || ([::ymhuk::user.place $nick] > $conf(command.places))) && !$let} {
		#    
		::ymhuk::pub.msg "\0032  !"
		return 0
	}
	#  
	set ymhuk(answered.nick) 	""
	set ymhuk(answer.chain) 	1
	# 
	set ymhuk(round) 0
	# 
	switch "$conf(cat.next.answer)" {
		1 {::ymhuk::pub.msg "\0032  :\00310 $ymhuk(answer)\0032.   \00313 5\0032 ."}
		0 {::ymhuk::pub.msg "\0032    !   \00313 5\0032 ."}
	}
	return 1
}

proc ::ymhuk::cat.question {nick} {
	variable ymhuk
	::ymhuk::notice $nick "  : $ymhuk(question)."
	return
}


#########################################
#########################################
####         ####
#########################################
#########################################


###########################################
####          ####  
###########################################

#          
proc ::ymhuk::cat.form.letters {text} {
	variable ymhuk
	#
	set letters [string length $ymhuk(answer)]
	#
	set words [llength [split $ymhuk(answer) " "]]
	# 
	set out_string "\00313 $letters \0032[lindex {0   } [::ymhuk::check.number $letters]],\00313 $words \0032[lindex {0   } [::ymhuk::check.number $words]] \0032"
	return $out_string
}

putlog "yMHuk: Cat script loaded"