########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################


bind msg -|- !remort 	::ymhuk::remort
bind msg -|- !	::ymhuk::remort
bind msg -|- !settitle 	::ymhuk::set.title
bind msg -|- !		::ymhuk::set.title
bind msg -|- !rlist 	::ymhuk::r.list
bind msg -|- ! 	::ymhuk::r.list

proc ::ymhuk::get.remort {nick} {
	if {![validuser $nick]} { return 0 }
	set remort [getuser $nick xtra remort]
	if {![catch {expr $remort}]} {
		return $remort
	} else { return 0 }
	return
}

proc ::ymhuk::remort {nick uhost handle text} {
	variable conf; variable ymhuk
	set score [::ymhuk::get.score $nick]
	if {$score >= $conf(remort.score)} {
		::ymhuk::priv.msg $nick "[expr $score / $conf(remort.score)] [expr int($score / $conf(remort.score))]"
		set add_remort [expr int($score / $conf(remort.score))]
		set current_remort [::ymhuk::get.remort $nick]
		switch "$text" {
			ok {
				switch "$current_remort" {
					0 { setuser $nick xtra remort $add_remort }
					default { setuser $nick xtra remort [expr $current_remort + $add_remort] }
				}
				setuser $nick xtra ymhuk "0 [::ymhuk::get.answers $nick] [::ymhuk::get.answer.chain $nick] [::ymhuk::get.seconds $nick]"
				::ymhuk::priv.msg $nick "\00312  !   :\00313 [::ymhuk::get.remort $nick]\00312.   \00313 0\00312 ."
				::ymhuk::priv.msg $nick "\00312        \00310 !rlist\00312."
			}
			default {
				::ymhuk::priv.msg $nick "\00312 \00313 $score\00312 [lindex {0   } [::ymhuk::check.number $score]]    ."
				::ymhuk::priv.msg $nick "\00312    \00313 $add_remort\00312 [lindex {0   } [::ymhuk::check.number $add_remort]].     ,     ."
				::ymhuk::priv.msg $nick "\00312  :\00313 $current_remort\00312.  [lindex {0   } [::ymhuk::check.number $add_remort]]?   \00310 !remort ok\00312."
			}
		}
	} else {
		::ymhuk::priv.msg $nick "\00312     .    \00313 [expr $conf(remort.score) - $score]\00312."
	}
	return
}

proc ::ymhuk::remort.bonus {nick} {
	variable conf; variable ymhuk
	set remort [::ymhuk::get.remort $nick]
	if {$remort >= $conf(r.set.bonus)} {
		set ver [expr rand() + (0.05*[expr $remort - $conf(r.set.bonus) + 1])]
		if {$ver >= $conf(r.ver)} {
			set ymhuk(r.bonus) [expr round(rand()*[expr $remort - $conf(r.set.bonus) + 1]*$conf(rand.bonus))]
			if {!$ymhuk(r.bonus)} { return 0 } else {
				incr ymhuk(bonus) $ymhuk(r.bonus)
				return 1
			}
		}
	}
	return 0
}

proc ::ymhuk::set.title {nick uhost handle text} {
	variable conf
	if {[::ymhuk::get.remort $nick] < $conf(r.set.title)} {
		::ymhuk::priv.msg $nick "\00312    !"
		return
	}
	set text [::egglib::strip_colors $text]
	if {$text == ""} {
		::ymhuk::priv.msg $nick "\00312   !"
		return
	}
	if {[string length $text] > $conf(title.length)} {
		::ymhuk::priv.msg $nick "\00312  !       \00313 $conf(title.length)\00312 [lindex {0   } [::ymhuk::check.number $conf(title.length)]]."
		return
	}
	setuser $nick xtra title $text
	::ymhuk::priv.msg $nick "\00312   '$text'."
	return
}

proc ::ymhuk::r.list {nick uhost handle text} {
	variable conf
	set remort [::ymhuk::get.remort $nick]
	::ymhuk::priv.msg $nick "\00312    :\00313 $conf(r.choose)"
	::ymhuk::priv.msg $nick "\00312      !  !:\00313 $conf(r.commands)"
	::ymhuk::priv.msg $nick "\00312       :\00313 $conf(r.set.bonus)"
	::ymhuk::priv.msg $nick "\00312      (:\00310 !settitle <>\00312):\00313 $conf(r.set.title)"
	::ymhuk::priv.msg $nick "\00312   :\00313 $remort"
	return
}