########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################



#######################################
#######################################
####              ####
#######################################
#######################################

#     
proc ::ymhuk::sharads.init {} {
	variable conf; variable ymhuk
	#      ,      
	if {[getuser $conf(owner) xtra sharads] == ""} {
		setuser $conf(owner) xtra sharads 0
	}
	# -,      
	set ymhuk(sharads.counter) [getuser $conf(owner) xtra sharads]
}

proc ::ymhuk::sharads.load.base {} {
	variable conf; variable ymhuk
	::ymhuk::pub.msg "\00312  ,     ..."
	::ymhuk::sharads.init
	set ymhuk(s.positons) ""
	catch {open $conf(sharads.base) r} f
	while {![eof $f]} {
		set position [tell $f]
		set line [string trim [gets $f]]
		lappend ymhuk(s.positions) $position
	}
	close $f
	set ymhuk(sharads.base.length) [llength $ymhuk(s.positions)]
	switch "$conf(s.random.type)" {
		1 {
			if {($ymhuk(sharads.counter) > ([expr [llength $ymhuk(s.positions)] - 1]))} { set ymhuk(sharads.counter) 0 }
			set ymhuk(s.positions) [lreplace $ymhuk(s.positions) 0 [expr $ymhuk(sharads.counter) - 1]]
		}
		0 {}
	}
	return
}

proc ::ymhuk::sharads.sql.load.base {} {
	variable conf; variable ymhuk
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from sharads;"]
	set ymhuk(sharads.base.length) [::mysql::fetch $q]
	::mysql::endquery $q
	switch "$conf(s.random.type)" {
		1 {
			set q [::mysql::query $ymhuk(sql.con) "select s_counter from counters where id = 1;"]
			set ymhuk(sharads.counter) [::mysql::fetch $q]
			::mysql::endquery $q
			if {$ymhuk(sharads.counter) > $ymhuk(sharads.base.length)} {
				set ymhuk(sharads.counter) 1
				::mysql::exec $ymhuk(sql.con) "update counters set s_counter = $ymhuk(sharads.counter) where id = 1;"
			}
		}
		0 {}
	}
	return
}

################################################
################################################
####            ####
################################################
################################################

#  
proc ::ymhuk::sharads.out {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$conf(sql.enable)" {
		0 {
			if {![info exists ymhuk(s.positions)] || ![llength $ymhuk(s.positions)]} {
				::ymhuk::sharads.load.base
			}
			switch "$conf(s.random.type)" {
				1 {	
					catch {open $conf(sharads.base) r} f
					seek $f [lindex $ymhuk(s.positions) 0]
					set ymhuk(s.data) [gets $f]
					close $f
					set ymhuk(s.positions) [lreplace $ymhuk(s.positions) 0 0]
					incr ymhuk(sharads.counter)
					setuser $conf(owner) xtra sharads $ymhuk(sharads.counter)
					set number $ymhuk(sharads.counter)
				}
				0 {
					catch {open $conf(sharads.base) r} f
					set i [expr int(rand() * [expr [llength $ymhuk(s.positions)] - 1])]
					seek $f [lindex $ymhuk(s.positions) $i]
					set ymhuk(s.data) [gets $f]
					close $f
					set ymhuk(s.positions) [lreplace $ymhuk(s.positions) $i $i]
				}
			}
			foreach {ymhuk(question) ymhuk(answer)} [split $ymhuk(s.data) "|"] {break}
		}
		1 {
			if {![::ymhuk::sql.ping]} {
				putlog "\0034    !    ."
				::ymhuk::kill.timers
				unset ymhuk(game)
				return
			}
			if {![info exists ymhuk(sharads.base.length)]} {
				::ymhuk::sharads.sql.load.base
			}
			switch "$conf(s.random.type)" {
				0 {
					set i [expr int(rand() * $ymhuk(sharads.base.length)) + 1]
					set q [::mysql::query $ymhuk(sql.con) "select sharada, answer from sharads where id = $i;"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
				}
				1 {
					if {$ymhuk(sharads.counter) > $ymhuk(sharads.base.length)} {
						set ymhuk(sharads.counter) 1
					}
					set q [::mysql::query $ymhuk(sql.con) "select sharada, answer from sharads where id = $ymhuk(sharads.counter);"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
					set number $ymhuk(sharads.counter)
					incr ymhuk(sharads.counter)
					::mysql::exec $ymhuk(sql.con) "update counters set s_counter = $ymhuk(sharads.counter);"
				}
			}
		}
	}
	# 
	#   
	set ymhuk(round) 1
	switch "$conf(s.random.type)" {
		1 {
			::ymhuk::pub.msg "\0033\037\017 \0033$number:"
			foreach item [split $ymhuk(question) "\*"] {
				::ymhuk::pub.msg "\0037$item"
			}
		}
		0 {
			::ymhuk::pub.msg "\0033\037\017\0033:"
			foreach item [split $ymhuk(question) "\*"] {
				::ymhuk::pub.msg "\0037$item"
			}
		}
	}
	#   
	set ymhuk(start.sec) [clock seconds]
	set ymhuk(start.ms) [clock click -milliseconds]
	#    (      " ")
	utimer $conf(sharads.roundtime) [list ::ymhuk::sharads.no.answer $nick $uhost $handle $chan $text]
	#  
	set ymhuk(bonus) $conf(sharads.answer.points)
	#     
	set ymhuk(hint2.allow)	0
	set ymhuk(need.hint2)	0
	# ,      ,     
	set ymhuk(got.hint1) 	0
	set ymhuk(got.hint2) 	0
	#    
	utimer $conf(sharads.hint2.allow) [list ::ymhuk::sharads.hint2]
	return
}


#################################################
#################################################
####            ####
#################################################
#################################################

#    
proc ::ymhuk::sharads.no.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,  -  ,   
	incr ymhuk(no.answer)
	#  
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	# 
	switch "$conf(sharads.show.answer)" {
		1 {::ymhuk::pub.msg "\0033    .  :\0037 $ymhuk(answer)\0033. ."}
		0 {::ymhuk::pub.msg "\0033    . ."}
	}
	#      , 
	if {[::ymhuk::self.stop] == 1} { return }
	# 
	set ymhuk(round) 0
	#    
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
}


#######################################
#######################################
####           ####
#######################################
#######################################

proc ::ymhuk::sharads.output {nick} {
	variable conf; variable ymhuk
	# 
	switch "$conf(sharads.right.answer)" {
		1 {::ymhuk::pub.msg "\0033,\0037 $nick\0033!  :\0034 $ymhuk(answer)\0033.   \00312 $ymhuk(answer.time) \0033."}
		0 {::ymhuk::pub.msg "\0033,\0037 $nick\0033!   !   \00312 $ymhuk(answer.time) \0033."}
	}
	#  
	::ymhuk::increase.on.answer $nick
	#C       
	set points [::ymhuk::get.score $nick]
	#  " --..."
	::ymhuk::pub.msg "\0033!   \0037 $nick\0033 \00312 $ymhuk(bonus)\0033 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \00313 $points\0033 [lindex {0   } [::ymhuk::check.number $points]]."
	# ,      5  ,   
	if {[expr $ymhuk(answer.chain) % 5] == 0} {
		set lst " $nick ,\00313 $nick\003  ,\00312 $nick\003,\00312 $nick\003    , \00312 $nick\003  "
		# 10   -  ( -  )
		if {[expr $ymhuk(answer.chain) % 10] == 0} {
			set ymhuk(bonus) $ymhuk(answer.chain)
			#   
			::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]   \0034 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]!"
			::ymhuk::increase.on.answer $nick
			return
		}
		#  -    10,   5,   
		::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]] !"
		return
	}
	return
}

proc ::ymhuk::sharads.out.change.place {nick} {
	variable ymhuk
	#     (   /  )
	if {$ymhuk(place.before) > $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0033!\0037 $nick\0033  \00313 $ymhuk(place.after)\0033 !"
		return
	}
	#     
	if {$ymhuk(place.before) < $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0033 ,\0037 $nick\0033  \00313 $ymhuk(place.after)\0033 !"
		return
	}
	return
}

proc ::ymhuk::sharads.next {nick} {
	variable conf; variable ymhuk
	set let [::ymhuk::command.let $nick]
	#        
	if {(([::ymhuk::check.user $nick] == 0) || ([::ymhuk::user.place $nick] > $conf(command.places))) && !$let} {
		#    
		::ymhuk::pub.msg "\0033!"
		return 0
	}
	#  
	set ymhuk(answered.nick) 	""
	set ymhuk(answer.chain) 	1
	# 
	set ymhuk(round) 0
	# 
	switch "$conf(sharads.next.answer)" {
		1 {::ymhuk::pub.msg "\0033   :\0034 $ymhuk(answer)\0033. ."}
		0 {::ymhuk::pub.msg "\0033  ! ."}
	}
	return 1
}

proc ::ymhuk::sharads.question {nick} {
	variable ymhuk
	::ymhuk::notice $nick ": $ymhuk(shar.str)."
	return
}


#########################
####        ####
#########################

# 
proc ::ymhuk::sharads.hint1 {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {($conf(sharads.hint) == 0) || ($chan != $conf(chan)) || ($ymhuk(round) == 0)} {
		return
	}
	#   " "
	if {$conf(sharads.decrease.points) == 1} {
		# ,             
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $conf(sharads.decr.user.points.h1))} {
			# ,    
			::ymhuk::pub.msg "\0037$nick\0033, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
		#   ,    
		if {($ymhuk(got.hint1) == 1) || ($ymhuk(got.hint2) == 1)} {
			::ymhuk::pub.msg "\0033  !"
			return
		}
	}
	set ymhuk(hint1) ""
	#      
	if {[string length $ymhuk(answer)] <=3} {
		::ymhuk::pub.msg "\0033  !"
		return
	} else {
		#  
		set ymhuk(hint1) [::ymhuk::convert.word.single $ymhuk(answer)]
	}
	#  
	switch "$conf(sharads.decrease.points)" {
		1 {
			set ymhuk(got.hint1) 1
			::ymhuk::pub.msg "\0033  \0037 $nick\00312 $conf(sharads.decr.user.points.h1)\0033 [lindex {0   } [::ymhuk::check.number $conf(sharads.decr.user.points.h1)]]!"
			::ymhuk::pub.msg "\0033:\003 $ymhuk(hint1)"
			::ymhuk::decrease $nick $conf(sharads.decr.user.points.h1)
		}
		0 { set ymhuk(bonus) $conf(sharads.points.after.h1)
			::ymhuk::pub.msg "\0033:\003 $ymhuk(hint1)"
		}
	}
	return
}

#     
proc ::ymhuk::sharads.hint2 {} {
	variable conf; variable ymhuk
	#  ,   ,      , 
	if {($conf(hint) == 0) || ($ymhuk(round) == 0) || ($ymhuk(need.hint2) == 0)} {
		#   
		set ymhuk(hint2.allow) 1
		set ymhuk(need.hint2) 1
		return
	}
	set ymhuk(hint2) ""
	#       
	switch -regexp -- "[string length $ymhuk(answer)]" {
		^1$ 		{::ymhuk::pub.msg "\0033  !"; return}
		^2$|^3$ 	{set ymhuk(hint2) [::ymhuk::convert.word.single $ymhuk(answer)]}
		^4$|^5$ 	{set ymhuk(hint2) [::ymhuk::convert.word.double $ymhuk(answer)]}
		default		{set ymhuk(hint2) [::ymhuk::convert.word.trio 	$ymhuk(answer)]}
	}
	#  
	switch "$conf(sharads.decrease.points)" {
		1 {
			set ymhuk(got.hint2) 1
			::ymhuk::pub.msg "\0033  \0037 $ymhuk(hint2.nick)\00312 $conf(sharads.decr.user.points.h2)\0033 [lindex {0   } [::ymhuk::check.number $conf(sharads.decr.user.points.h2)]]!"
			::ymhuk::pub.msg "\0033:\003 $ymhuk(hint2)"
			::ymhuk::decrease $ymhuk(hint2.nick) $conf(sharads.decr.user.points.h2)
		}
		0 { set ymhuk(bonus) $conf(sharads.points.after.h2)
			::ymhuk::pub.msg "\0033:\003 $ymhuk(hint2)"
		}
	}
	#  
	set ymhuk(hint2.allow) 1
	return
}

#    
proc ::ymhuk::sharads.hint2.allow {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {!$conf(sharads.hint) || ($chan != $conf(chan)) || !$ymhuk(round)} {
		return
	}
	if {$conf(sharads.decrease.points) == 1} {
		if {$ymhuk(got.hint2) == 1} {
			::ymhuk::pub.msg "\0033   !"
			return
		}
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $conf(sharads.decr.user.points.h2))} {
			::ymhuk::pub.msg "\0037$nick\0033, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
	}
	set ymhuk(hint2.nick) $nick
	#    ,  ,          
	if {$ymhuk(hint2.allow) == 0} {
		set hint2_seconds [::ymhuk::sharads.hint2.seconds]
		# ,  
		switch "$conf(sharads.decrease.points)" {
			1 { 
				set ymhuk(need.hint2) 1
				set ymhuk(got.hint2) 1
				::ymhuk::pub.msg "\0033    \00312 $conf(sharads.decr.user.points.h2)\0033 [lindex {0   } [::ymhuk::check.number $conf(sharads.decr.user.points.h2)]]!   \00313 $hint2_seconds\0033 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"	
				return
			}
			0 {
				set ymhuk(need.hint2) 1
				::ymhuk::pub.msg "\0033 !   \00313 $hint2_seconds\0033 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"
				return
			}
		}
	} else {
		#  ,   
		::ymhuk::sharads.hint2
		return
	}
	return
}


#########################################
#########################################
####         ####
#########################################
#########################################


# - ,     
proc ::ymhuk::sharads.hint2.seconds {} {
	foreach u [utimers] {
		#  
		if {[string match -nocase "*sharads.hint2*" [lindex $u 1]]} {
			set hint2_seconds [lindex $u 0]
			
		}
	}
	# - 
	return $hint2_seconds
}


putlog "yMHuk: Sharads script loaded"