########################################################################
########################################################################
##   _____        _____                             ___               ##
##   \    \      /    /                            |   |       TM     ##
##    \    \    /    /       ____     ____         |   |              ##
##     \    \  /    /       |    |   |    |        |   |              ##
##      \    \/    /        |    |   |    |        |   |   ____       ##
##       \        /_      ___    |   |    |__    __|   |  /   /       ##
##        \      /  \    /   |   |   |    |  \  /  \   | /   /        ##
##        /     /    \__/    |   |___|    |  |  |  |   |/   /         ##
##       /     /|            |            |  |  |  |       /          ##
##      /     / |            |    ___     |  \__/  |       \          ##
##     /     /  |     __     |   |   |    |         \  |\   \         ##
##    /_____/   |____|  |____|___|   |____|\_____/\__\_| \___\        ##
##                                                                    ##
##                                                   Dominion        ##
##                                                                    ##
########################################################################
########################################################################
#                                                                      #
#                 yMHuk v2.7 by Dominion(aka )                    #
#                                                                      #
#                                                                      #
#               readme.txt        #
#                                                                      #
########################################################################



#######################################
#######################################
####           ####
#######################################
#######################################

#     
proc ::ymhuk::plain.initialization {} {
	variable conf; variable ymhuk
	#      ,      
	if {[getuser $conf(owner) xtra counter] == ""} {
		setuser $conf(owner) xtra counter 0
	}
	# -,      
	set ymhuk(q.counter) [getuser $conf(owner) xtra counter]
}


proc ::ymhuk::plain.load.base {} {
	variable conf; variable ymhuk
	::ymhuk::pub.msg "\00312  ,     ..."
	::ymhuk::plain.initialization
	set ymhuk(q.positons) ""
	catch {open $conf(questions) r} f
	while {![eof $f]} {
		set position [tell $f]
		set line [string trim [gets $f]]
		lappend ymhuk(q.positions) $position
	}
	close $f
	set ymhuk(baselength) [llength $ymhuk(q.positions)]
	switch "$conf(random.type)" {
		1 {
			if {($ymhuk(q.counter) > ([expr [llength $ymhuk(q.positions)] - 1]))} { set ymhuk(q.counter) 0 }
			set ymhuk(q.positions) [lreplace $ymhuk(q.positions) 0 [expr $ymhuk(q.counter) - 1]]
		}
		0 {}
	}
	return
}

proc ::ymhuk::plain.sql.load.base {} {
	variable conf; variable ymhuk
	set q [::mysql::query $ymhuk(sql.con) "select count(*) from questions;"]
	set ymhuk(baselength) [::mysql::fetch $q]
	::mysql::endquery $q
	switch "$conf(random.type)" {
		1 {
			set q [::mysql::query $ymhuk(sql.con) "select q_counter from counters where id = 1;"]
			set ymhuk(q.counter) [::mysql::fetch $q]
			::mysql::endquery $q
			if {$ymhuk(q.counter) > $ymhuk(baselength)} {
				set ymhuk(q.counter) 1
				::mysql::exec $ymhuk(sql.con) "update counters set q_counter = $ymhuk(q.counter) where id = 1;"
			}
		}
		0 {}
	}
	return
}

################################################
################################################
####            ####
################################################
################################################

#  
proc ::ymhuk::plain.out.questions {nick uhost handle chan text} {
	variable conf; variable ymhuk
	switch "$conf(sql.enable)" {
		0 {
			if {![info exists ymhuk(q.positions)] || ![llength $ymhuk(q.positions)]} {
				::ymhuk::plain.load.base
			}
			switch "$conf(random.type)" {
				1 {	
					catch {open $conf(questions) r} f
					seek $f [lindex $ymhuk(q.positions) 0]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) 0 0]
					incr ymhuk(q.counter)
					setuser $conf(owner) xtra counter $ymhuk(q.counter)
					set number [expr $ymhuk(q.counter)]
				}
				0 {
					catch {open $conf(questions) r} f
					set i [expr int(rand() * [expr [llength $ymhuk(q.positions)] - 1])]
					seek $f [lindex $ymhuk(q.positions) $i]
					set ymhuk(q.data) [gets $f]
					close $f
					set ymhuk(q.positions) [lreplace $ymhuk(q.positions) $i $i]
				}
			}
		#  "|"    
		foreach {ymhuk(question) ymhuk(answer)} [split $ymhuk(q.data) "|"] {break}
		}
		1 {
			if {![::ymhuk::sql.ping]} {
				putlog "\0034    !    ."
				::ymhuk::kill.timers
				unset ymhuk(game)
				return
			}
			if {![info exists ymhuk(baselength)]} {
				::ymhuk::plain.sql.load.base
			}
			switch "$conf(random.type)" {
				0 {
					set i [expr int(rand() * $ymhuk(baselength)) + 1]
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $i;"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
				}
				1 {
					if {$ymhuk(q.counter) > $ymhuk(baselength)} {
						set ymhuk(q.counter) 1
					}
					set q [::mysql::query $ymhuk(sql.con) "select question, answer from questions where id = $ymhuk(q.counter);"]
					set raw [::mysql::fetch $q]
					set ymhuk(question) [lindex $raw 0]
					set ymhuk(answer) [lindex $raw 1]
					::mysql::endquery $q
					set number $ymhuk(q.counter)
					incr ymhuk(q.counter)
					::mysql::exec $ymhuk(sql.con) "update counters set q_counter = $ymhuk(q.counter);"
				}
			}
		}
	}
	# -   
	set ymhuk(q.words) [llength [split $ymhuk(answer) " "]]
	#   
	set ymhuk(round) 1
	# 
	switch "$conf(random.type)" {
		1 {
			::ymhuk::pub.msg "\0035\037\017 \0035$number:\00312 $ymhuk(question) ([::ymhuk::form.letters $ymhuk(answer)])"
		}
		0 {
			::ymhuk::pub.msg "\0035\037\017\0035:\00312 $ymhuk(question) ([::ymhuk::form.letters $ymhuk(answer)])"
		}
	}
	#   
	set ymhuk(start.sec) [clock seconds]
	set ymhuk(start.ms) [clock click -milliseconds]
	#    (      " ")
	utimer $conf(roundtime) [list ::ymhuk::plain.no.answer $nick $uhost $handle $chan $text]
	#  
	set ymhuk(bonus) $conf(main.answer.points)
	#     
	set ymhuk(hint2.allow)	0
	set ymhuk(need.hint2)	0
	# ,      ,     
	set ymhuk(got.hint1) 	0
	set ymhuk(got.hint2) 	0
	if {$conf(auto.hint1)} {
		utimer $conf(auto.hint1.time) [list ::ymhuk::plain.auto.hint1]
	}
	switch "$conf(auto.hint2)" {
		1 {
			utimer $conf(auto.hint2.time) [list ::ymhuk::plain.auto.hint2]
		}
		0 {
			utimer $conf(hint2.allow) [list ::ymhuk::plain.hint2]
		}
	}
	return
}

#################################################
#################################################
####            ####
#################################################
#################################################

#    
proc ::ymhuk::plain.no.answer {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#   ,  -  ,   
	incr ymhuk(no.answer)
	#  
	set ymhuk(answered.nick) 	""
	#  
	set ymhuk(answer.chain) 	1
	# 
	switch "$conf(show.answer)" {
		1 {::ymhuk::pub.msg "\0035 ,  :\0034 $ymhuk(answer)\0035.   \0033 5 \0035."}
		0 {::ymhuk::pub.msg "\0035 ,    .   \0033 5 \0035."}
	}
	#      , 
	if {[::ymhuk::self.stop] == 1} { return }
	# 
	set ymhuk(round) 0
	#    
	utimer 5 [list ::ymhuk::main $nick $uhost $handle $chan $text]
}


#######################################
#######################################
####           ####
#######################################
#######################################

proc ::ymhuk::plain.output {nick} {
	variable conf; variable ymhuk
	# 
	switch "$conf(right.answer)" {
		1 {::ymhuk::pub.msg "\0035,\0033 $nick\0035!  :\0034 $ymhuk(answer)\0035.   \0033 $ymhuk(answer.time) \0035."}
		0 {::ymhuk::pub.msg "\0035,\0033 $nick\0035!   !   \0033 $ymhuk(answer.time) \0035."}
	}
	if {[::ymhuk::remort.bonus $nick]} {
		::ymhuk::pub.msg "\0035,      \0033 $nick \0035 \0034 $ymhuk(r.bonus) \0035[lindex {0   } [::ymhuk::check.number $ymhuk(r.bonus)]]!"
	}
	#  
	::ymhuk::increase.on.answer $nick
	#C       
	set points [::ymhuk::get.score $nick]
	#  " --..."
	::ymhuk::pub.msg "\0035!\0033 $nick\0035 \0034 $ymhuk(bonus)\0035 [lindex {0   } [::ymhuk::check.number $ymhuk(bonus)]]  \00313 $points\0035 [lindex {0   } [::ymhuk::check.number $points]]."
	# ,      5  ,   
	if {[expr $ymhuk(answer.chain) % 5] == 0} {
		set lst " $nick ,\00313 $nick\003  ,\00312 $nick\003,\00312 $nick\003    , \00312 $nick\003  "
		# 10   -  ( -  )
		if {[expr $ymhuk(answer.chain) % 10] == 0} {
			set ymhuk(bonus) $ymhuk(answer.chain)
			#   
			::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]   \0034 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]]!"
			::ymhuk::increase.on.answer $nick
			return
		}
		#  -    10,   5,   
		::ymhuk::action "[lindex [split $lst ","] [rand 5]] \00313 $ymhuk(answer.chain)\003 [lindex {0   } [::ymhuk::check.number $ymhuk(answer.chain)]] !"
		return
	}
	return
}

proc ::ymhuk::plain.out.change.place {nick} {
	variable ymhuk
	#     (   /  )
	if {$ymhuk(place.before) > $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0035!\0033 $nick\0035  \00312 $ymhuk(place.after)\0035 !"
		return
	}
	#     
	if {$ymhuk(place.before) < $ymhuk(place.after)} {
		#  
		::ymhuk::pub.msg "\0035 ,\0033 $nick\0035  \00312 $ymhuk(place.after)\0035 !"
		return
	}
	return
}


proc ::ymhuk::plain.next {nick} {
	variable conf; variable ymhuk
	set let [::ymhuk::command.let $nick]
	#        
	if {(([::ymhuk::check.user $nick] == 0) || ([::ymhuk::user.place $nick] > $conf(command.places))) && !$let} {
		#    
		::ymhuk::pub.msg "\0035 , .      !"
		return 0
	}
	#  
	set ymhuk(answered.nick) 	""
	set ymhuk(answer.chain) 	1
	# 
	set ymhuk(round) 0
	# 
	switch "$conf(next.answer)" {
		1 {::ymhuk::pub.msg "\0035 - :\0034 $ymhuk(answer)\0035.   \0033 5\0035 ."}
		0 {::ymhuk::pub.msg "\0035  !   \0033 5\0035 ."}
	}
	return 1
}

proc ::ymhuk::plain.question {nick} {
	variable ymhuk
	::ymhuk::notice $nick ": $ymhuk(question)."
	return
}


#########################
####        ####
#########################

# 
proc ::ymhuk::plain.hint1 {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {!$conf(hint) || ($chan != $conf(chan)) || !$ymhuk(round) || $conf(auto.hint1)} {
		return
	}
	#   " "
	if {$conf(decrease.points) == 1} {
		# ,             
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $conf(decr.user.points.h1))} {
			# ,    
			::ymhuk::pub.msg "\0033$nick\0035, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
		#   ,    
		if {($ymhuk(got.hint1) == 1) || ($ymhuk(got.hint2) == 1)} {
			::ymhuk::pub.msg "\0035  !"
			return
		}
	}
	set ymhuk(hint1) ""
	#    
	if {$ymhuk(q.words) > 1} {
		set i 0
		set listword [split $ymhuk(answer) " "]
		# ,      
		while {$i < [llength $listword]} {
			set word [::ymhuk::convert.word.single [lindex $listword $i]]
			#  
			append ymhuk(hint1) "$word\003 "
			incr i
		}
	#  
	} else {
		#      
		if {[string length $ymhuk(answer)] <=3} {
			::ymhuk::pub.msg "\0035  !"
			return
		} else {
			#  
			set ymhuk(hint1) [::ymhuk::convert.word.single $ymhuk(answer)]
		}
	}
	#  
	switch "$conf(decrease.points)" {
		1 {
			set ymhuk(got.hint1) 1
			::ymhuk::pub.msg "\0035  \0033 $nick\0034 $conf(decr.user.points.h1)\0035 [lindex {0   } [::ymhuk::check.number $conf(decr.user.points.h1)]]!"
			::ymhuk::pub.msg "\0035:\003 $ymhuk(hint1)"
			::ymhuk::decrease $nick $conf(decr.user.points.h1)
		}
		0 { set ymhuk(bonus) $conf(points.after.h1)
			::ymhuk::pub.msg "\0035:\003 $ymhuk(hint1)"
		}
	}
	return
}

#     
proc ::ymhuk::plain.hint2 {} {
	variable conf; variable ymhuk
	#  ,   ,      , 
	if {($conf(hint) == 0) || ($ymhuk(round) == 0) || ($ymhuk(need.hint2) == 0)} {
		#   
		set ymhuk(hint2.allow) 1
		set ymhuk(need.hint2) 1
		return
	}
	set ymhuk(hint2) ""
	#    
	if {$ymhuk(q.words) > 1} {
		set i 0
		set listword [split $ymhuk(answer) " "]
		# ,      
		while {$i < [llength $listword]} {
			set word [::ymhuk::convert.word.double [lindex $listword $i]]
			#  
			append ymhuk(hint2) "$word\003 "
			incr i
		}
	} else {
		#       
		switch -regexp -- "[string length $ymhuk(answer)]" {
			^1$ 		{::ymhuk::pub.msg "\0035  !"; return}
			^2$|^3$ 	{set ymhuk(hint2) [::ymhuk::convert.word.single $ymhuk(answer)]}
			^4$|^5$ 	{set ymhuk(hint2) [::ymhuk::convert.word.double $ymhuk(answer)]}
			default		{set ymhuk(hint2) [::ymhuk::convert.word.trio 	$ymhuk(answer)]}
		}
	}
	#  
	switch "$conf(decrease.points)" {
		1 {
			set ymhuk(got.hint2) 1
			::ymhuk::pub.msg "\0035  \0033 $ymhuk(hint2.nick)\0034 $conf(decr.user.points.h2)\0035 [lindex {0   } [::ymhuk::check.number $conf(decr.user.points.h2)]]!"
			::ymhuk::pub.msg "\0035:\003 $ymhuk(hint2)"
			::ymhuk::decrease $ymhuk(hint2.nick) $conf(decr.user.points.h2)
		}
		0 { set ymhuk(bonus) $conf(points.after.h2)
			::ymhuk::pub.msg "\0035:\003 $ymhuk(hint2)"
		}
	}
	#  
	set ymhuk(hint2.allow) 1
	return
}

#    
proc ::ymhuk::plain.hint2.allow {nick uhost handle chan text} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {!$conf(hint) || ($chan != $conf(chan)) || !$ymhuk(round) || $conf(auto.hint2)} {
		return
	}
	if {$conf(decrease.points) == 1} {
		if {$ymhuk(got.hint2) == 1} {
			::ymhuk::pub.msg "\0035   !"
			return
		}
		if {([::ymhuk::check.user $nick] == 0) || ([::ymhuk::get.score $nick] < $conf(decr.user.points.h2))} {
			::ymhuk::pub.msg "\0033$nick\0035, [lindex [split {   !,  !,   !,   !,     !} ","] [rand 5]]"
			return
		}
	}
	set ymhuk(hint2.nick) $nick
	#    ,  ,          
	if {$ymhuk(hint2.allow) == 0} {
		set hint2_seconds [::ymhuk::hint2.seconds]
		# ,  
		switch "$conf(decrease.points)" {
			1 { 
				set ymhuk(need.hint2) 1
				set ymhuk(got.hint2) 1
				::ymhuk::pub.msg "\0035    \0034 $conf(decr.user.points.h2)\0035 [lindex {0   } [::ymhuk::check.number $conf(decr.user.points.h2)]]!   \0034 $hint2_seconds\0035 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"	
				return
			}
			0 {
				set ymhuk(need.hint2) 1
				::ymhuk::pub.msg "\0035 !   \0034 $hint2_seconds\0035 [lindex {0   } [::ymhuk::check.number $hint2_seconds]]!"
				return
			}
		}
	} else {
		#  ,   
		::ymhuk::plain.hint2
		return
	}
	return
}

###################      ######################

# 
proc ::ymhuk::plain.auto.hint1 {} {
	variable conf; variable ymhuk
	#  ,   ,   ,   
	if {($conf(hint) == 0) || ($ymhuk(round) == 0)} {
		return
	}
	set ymhuk(hint1) ""
	#    
	if {$ymhuk(q.words) > 1} {
		set i 0
		set listword [split $ymhuk(answer) " "]
		# ,      
		while {$i < [llength $listword]} {
			set word [::ymhuk::convert.word.single [lindex $listword $i]]
			#  
			append ymhuk(hint1) "$word\003 "
			incr i
		}
	#  
	} else {
		#      
		if {[string length $ymhuk(answer)] <=3} {
			::ymhuk::pub.msg "\0035     !"
			return
		} else {
			#  
			set ymhuk(hint1) [::ymhuk::convert.word.single $ymhuk(answer)]
		}
	}
	#  
	set ymhuk(bonus) $conf(points.after.h1)
	::ymhuk::pub.msg "\0035 1:\003 $ymhuk(hint1)"
	return
}

proc ::ymhuk::plain.auto.hint2 {} {
	variable conf; variable ymhuk
	#  ,   ,      , 
	if {($conf(hint) == 0) || ($ymhuk(round) == 0)} {
		return
	}
	set ymhuk(hint2) ""
	#    
	if {$ymhuk(q.words) > 1} {
		set i 0
		set listword [split $ymhuk(answer) " "]
		# ,      
		while {$i < [llength $listword]} {
			set word [::ymhuk::convert.word.double [lindex $listword $i]]
			#  
			append ymhuk(hint2) "$word\003 "
			incr i
		}
	} else {
		#       
		switch -regexp -- "[string length $ymhuk(answer)]" {
			^1$ 		{::ymhuk::pub.msg "\0035     !"; return}
			^2$|^3$ 	{set ymhuk(hint2) [::ymhuk::convert.word.single $ymhuk(answer)]}
			^4$|^5$ 	{set ymhuk(hint2) [::ymhuk::convert.word.double $ymhuk(answer)]}
			default		{set ymhuk(hint2) [::ymhuk::convert.word.trio 	$ymhuk(answer)]}
		}
	}
	#  
	set ymhuk(bonus) $conf(points.after.h2)
	::ymhuk::pub.msg "\0035 2:\003 $ymhuk(hint2)"
	return
}

#########################################
#########################################
####         ####
#########################################
#########################################


# - ,     
proc ::ymhuk::hint2.seconds {} {
	foreach u [utimers] {
		#  
		if {[string match -nocase "*hint2*" [lindex $u 1]]} {
			set hint2_seconds [lindex $u 0]
			
		}
	}
	# - 
	return $hint2_seconds
}

###########################################
####          ####  
###########################################

#          
proc ::ymhuk::form.letters {text} {
	variable ymhuk
	#
	set letters [string length $ymhuk(answer)]
	#
	set words [llength [split $ymhuk(answer) " "]]
	# 
	set out_string "\0033 $letters \0035[lindex {0   } [::ymhuk::check.number $letters]],\0033 $words \0035[lindex {0   } [::ymhuk::check.number $words]] \00312"
	return $out_string
}

putlog "yMHuk: Viktorina script loaded"